head	1.13;
access;
symbols;
locks; strict;
comment	@ * @;


1.13
date	94.11.10.01.51.19;	author rushing;	state Exp;
branches;
next	1.12;

1.12
date	94.11.10.01.27.41;	author rushing;	state Exp;
branches;
next	1.11;

1.11
date	94.11.09.23.02.21;	author rushing;	state Exp;
branches;
next	1.10;

1.10
date	94.11.02.01.51.36;	author jcooper;	state Exp;
branches;
next	1.9;

1.9
date	94.09.16.00.57.09;	author jcooper;	state Exp;
branches;
next	1.8;

1.8
date	94.08.24.17.59.26;	author jcooper;	state Exp;
branches;
next	1.7;

1.7
date	94.08.11.00.09.17;	author jcooper;	state Exp;
branches;
next	1.6;

1.6
date	94.06.09.18.51.30;	author rushing;	state Exp;
branches;
next	1.5;

1.5
date	94.05.23.18.37.00;	author jcooper;	state Exp;
branches;
next	1.4;

1.4
date	94.05.19.02.02.10;	author rushing;	state Exp;
branches;
next	1.3;

1.3
date	94.02.24.21.27.10;	author jcoop;	state Exp;
branches;
next	1.2;

1.2
date	94.01.22.01.30.03;	author jcoop;	state Exp;
branches;
next	1.1;

1.1
date	94.01.16.12.10.08;	author jcoop;	state Exp;
branches;
next	;


desc
@jcoop's MIME and attachment routines
@


1.13
log
@removed logs
@
text
@/********************************************************************
 *                                                                  *
 *  MODULE    :  WVSEND.C                                           *
 *                                                                  *
 *  PURPOSE   : Send/attachment engine                              *
 *                                                                  *
 *  ENTRY POINTS: SendComposition(WndEdit *compWnd)                 *
 *                ReadTextFileIntoEditWnd ()                        *
 *                                                                  *
 * Author: John S. Cooper (jcooper@@netcom.com)                      *
 *   Date: Nov 28, 1993                                             *
 *                                                                  *
 *  Massive overhaul on oct 8, 1994 (jsc)                           *
 *   This is now the main post/mail engine, and now supports        *
 *   multi-attachments.  Changed name from wvattach to wvsend       *
 ********************************************************************/

/* 
 * $Id: wvsend.c 1.12 1994/11/10 01:27:41 rushing Exp rushing $
 */

#include <windows.h>
#include <windowsx.h>
#include "wvglob.h"
#include "winvn.h"
#pragma hdrstop
#include <string.h>
#include <ctype.h>				/* for isspace, isalnum, etc */
#include <stdlib.h>				/* for itoa */
#include <assert.h>
/*
 * Forward Declarations
 */
BOOL InitiateSend (WndEdit * compWnd);
void CompleteSend (WndEdit * compWnd, int action);
BOOL EndSendSection (WndEdit * compWnd);

BOOL GenerateMIMEVersion (TypTextBlock * header);
void GenerateMIMEAttachmentID ();
BOOL GenerateMIMEMultipartMixedHeader (TypTextBlock * textBlock);
BOOL GenerateMIMEPartialHeader (TypTextBlock * textBlock);
BOOL GenerateMIMEContentHeader (TypTextBlock * textBlock, TypAttachment * thisAttach);
BOOL CalcNumParts (WndEdit * compWnd);
void GenerateSubject (WndEdit * compWnd);

BOOL SendOneLineWithLen (char *str, unsigned long len);
BOOL SendOneLine (char *str);
BOOL SendTextBlock (TypTextBlock * textBlock);
BOOL SendEditText (HWND hWnd);
unsigned long SendPartialEditText (HWND hWnd, unsigned long startByte, unsigned long maxBytes);
unsigned long SendPartialTextFile (TypAttachment * thisAttach, unsigned long startByte, unsigned long maxBytes);

extern void UpdateBlockStatus ();	/* in wvcoding.c */

/*
 * Globals 
 */

/* NUM_ENCODING_TYPES should be set in wvglob.h to the # items here */
char *EncodingTypes[] =
{"Base-64", "UU", "XX", "Custom", "None"};

/* NUM_CONTENT_TYPES should be set in wvglob.h to the # items here */
char *ContentTypes[] =
{"Text/Plain",
 "Text/Richtext",
 "Video/MPEG",
 "Video/AVI",
 "Image/JPEG",
 "Image/GIF",
 "Audio/Basic",
 "Application/Zip",
 "Application/PostScript",
 "Other"};

#define ATTACH_NONE              0	/* state constants for DoSend */
#define ATTACH_START             1
#define ATTACH_FIRST_IN_THIS_WND 2
#define ATTACH_FIRST_IN_NEXT_WND 3
#define ATTACH_START_NEXT_SEND   4
#define ATTACH_MAIN              5
#define ATTACH_DONE              6
#define ATTACH_BEGIN_ATTACHMENT  7

int SendAttachNum;
TypTextBlock *MainHeader, *SectionHeader, *WorkBlock;
int SendingPart, SendNumParts;
int AttachmentState;
char origSubject[MAXHEADERLINE], attachmentID[MAXINTERNALLINE];
unsigned long SentNumBytes;

HFILE hMailLog, hPostLog;

/* To diagnose send/attachments by writing output to file instead of sending,
 * undef ENABLE_COMM_SEND, and activate mail/post logging 
 */
#define ENABLE_COMM_SEND

/* ---------------------------------------------------------------------------
 * EncodingTypeToNum converts a string describing a coding type into the
 * internal numeric representation
 */
int
EncodingTypeToNum (char *str)
{
  if (!stricmp (str, "Base-64"))
	return CODE_BASE64;
  else if (!stricmp (str, "UU"))
	return CODE_UU;
  else if (!stricmp (str, "XX"))
	return CODE_XX;
  else if (!stricmp (str, "Custom"))
	return CODE_CUSTOM;
  else if (!stricmp (str, "None"))
	return CODE_NONE;
  else
	return CODE_UNKNOWN;
}

/* ---------------------------------------------------------------------------
 * Logging
 */
void 
AbortMailLog (HWND hWnd)
{
  _snprintf (str, MAXINTERNALLINE, "Mail log error in file %s.  Logging disabled.", MailLogFile);
  MessageBox (hWnd, str, "Logging Error", MB_OK | MB_ICONINFORMATION);
  MailLog = FALSE;
  if (hMailLog) {
	_lclose (hMailLog);
	hMailLog = (HFILE) NULL;
  }
}
void 
AbortPostLog (HWND hWnd)
{
  _snprintf (str, MAXINTERNALLINE, "Post log error in file %s.  Logging disabled.", PostLogFile);
  MessageBox (hWnd, str, "Logging Error", MB_OK | MB_ICONINFORMATION);
  PostLog = FALSE;
  if (hPostLog) {
	_lclose (hPostLog);
	hPostLog = (HFILE) NULL;
  }
}

void 
LogLine (HWND hWnd, char *str, unsigned int len)
{
  if (SendingMail && MailLog && hMailLog) {
	if (_lwrite (hMailLog, str, len) == HFILE_ERROR) {
	  AbortMailLog (hWnd);
	}
  }
  if (SendingPost && PostLog && hPostLog) {
	if (_lwrite (hPostLog, str, len) == HFILE_ERROR) {
	  AbortPostLog (hWnd);
	}
  }
}

void 
InitLogging (HWND hWnd)
{
  OFSTRUCT ofs;
  char temp[MAXHEADERLINE], dateStr[MAXINTERNALLINE];
  int len;
  hMailLog = hPostLog = (HFILE) NULL;

  if (SendingPost && PostLog) {
	if (OpenFile (PostLogFile, &ofs, OF_EXIST) != HFILE_ERROR) {
	  if ((hPostLog = OpenFile (PostLogFile, &ofs, OF_WRITE)) == HFILE_ERROR) {
		AbortPostLog (hWnd);
	  }
	  else {
		if (_llseek (hPostLog, 0L, 2) == HFILE_ERROR) {		/* seek eof */
		  AbortPostLog (hWnd);
		}
	  }
	}
	else {
	  if ((hPostLog = OpenFile (PostLogFile, &ofs, OF_CREATE)) == HFILE_ERROR) {
		AbortPostLog (hWnd);
	  }
	}
  }

  // avoid logging mail if also logging post, and log files have same name
  if (SendingMail && MailLog &&
	  (!SendingPost || !PostLog || strcmp (MailLogFile, PostLogFile))) {
	if (OpenFile (MailLogFile, &ofs, OF_EXIST) != HFILE_ERROR) {
	  if ((hMailLog = OpenFile (MailLogFile, &ofs, OF_WRITE)) == HFILE_ERROR) {
		AbortMailLog (hWnd);
	  }
	  else {
		if (_llseek (hMailLog, 0L, 2) == HFILE_ERROR) {		/* seek eof */
		  AbortMailLog (hWnd);
		}
	  }
	}
	else {
	  if ((hMailLog = OpenFile (MailLogFile, &ofs, OF_CREATE)) == HFILE_ERROR) {
		AbortMailLog (hWnd);
	  }
	}
  }

  /* add a mailbox header */
  if (hMailLog || hPostLog) {
	GetMailboxDate (dateStr, MAXINTERNALLINE - 1);
	len = _snprintf (temp, MAXHEADERLINE, "From %s %s\r\n",
					 (*MailAddress) ? MailAddress : "Unknown", dateStr);
	LogLine (hWnd, temp, len);
  }
}

void 
EndLogging (HWND hWnd)
{
  /* add a blank line to the end */
  LogLine (hWnd, "\r\n", 2);
  if (SendingMail && MailLog && hMailLog) {
	_lclose (hMailLog);
  }
  if (SendingPost && PostLog && hPostLog) {
	_lclose (hPostLog);
  }
  hMailLog = hPostLog = (HFILE) NULL;
}

void 
AbortSendMail (HWND hNotifyWnd)
{
  SendingMail = FALSE;
  if (SendingPost) {
	MessageBox (hNotifyWnd, "Mail has failed.  Post will continue.", "Mail Failure", MB_OK | MB_ICONINFORMATION);
  }
  else {
	MessageBox (hNotifyWnd, "Mail has failed.  Send aborted.", "Mail Failure", MB_OK | MB_ICONINFORMATION);
  }
}

void 
AbortSendPost (HWND hNotifyWnd)
{
  SendingPost = FALSE;
  if (SendingMail) {
	MessageBox (hNotifyWnd, "Post has failed.  Mail will continue.", "Post Failure", MB_OK | MB_ICONINFORMATION);
  }
  else {
	MessageBox (hNotifyWnd, "Post has failed.  Send aborted.", "Post Failure", MB_OK | MB_ICONINFORMATION);
  }
  CommBusy = FALSE;
  CommState = ST_NONE;
  SetStatbarText (NetDoc.hWndFrame, "", &NetDoc, TRUE, TRUE);
  InvalidateRect (NetDoc.hDocWnd, NULL, TRUE);
  if (CommDoc != &NetDoc) {
	SetStatbarText (CommDoc->hWndFrame, "", CommDoc, TRUE, TRUE);
	InvalidateRect (CommDoc->hDocWnd, NULL, TRUE);
  }
}

/* ---------------------------------------------------------------------------
 * Processes the ttachments in WndEdit->attachments
 */
BOOL 
SendComposition (WndEdit * compWnd)
{
  /* Initialize text blocks */
  if ((SectionHeader = InitTextBlock (compWnd->hWnd)) == NULL)
	return FAIL;
  if ((WorkBlock = InitTextBlock (compWnd->hWnd)) == NULL)
	return FAIL;
  if ((MainHeader = InitTextBlock (compWnd->hWnd)) == NULL)
	return FAIL;

  if (GenerateHeadersForSend (compWnd, MainHeader, origSubject) == FAIL)
	return FAIL;

  /* WinVN is stuck while sending -- this is released in CompleteSend */
  hSaveCursor = SetCursor (hHourGlass);
  SetCapture (compWnd->hWnd);

  SendingMail = compWnd->composeType == DOCTYPE_MAIL ||
	compWnd->composeType == DOCTYPE_FORWARD ||
	(compWnd->composeType == DOCTYPE_POSTING && *CcAddress);
  SendingPost = compWnd->composeType == DOCTYPE_POSTING;

  InitLogging (compWnd->hWnd);

  /* init hCodedBlockWnd and currentCoded */
  CodingState = ATTACH_WAITING;	/* status info */
  CreateStatusArea (compWnd->hWnd, "Send Status", SW_SHOWNORMAL);
  InvalidateRect (hCodedBlockWnd, NULL, TRUE);	/* clear background */

  /* set body (attachment 0) size */
  compWnd->attachment[0]->numBytes =
	(unsigned long) SendMessage (compWnd->hWndEdit, WM_GETTEXTLENGTH, 0, 0L);

  if (GenerateMIME) {
	if (GenerateMIMEVersion (MainHeader)) {
	  CompleteSend (compWnd, ABORT);
	  return FAIL;
	}
  }
  else {
	if (AddEndedLineToTextBlock (MainHeader, "")) {
	  CompleteSend (compWnd, ABORT);
	  return FAIL;
	}
  }

  // we need this global since when wvutil.c calls DoSend, it doesn't
  // have a handle to the current compose window
  ComposeWnd = compWnd;
  compWnd->busy = TRUE;

  // lock out changes during send
  SendMessage (compWnd->hWndEdit, EM_SETREADONLY, TRUE, 0L);
  EnableSendComposition (compWnd, FALSE);

  AttachmentState = ATTACH_START;
  DoSend (CONTINUE);
  return SUCCESS;
}

/* ---------------------------------------------------------------------------
 * DoSend
 * this is written as a state machine to allow interruption in !ReviewMode
 * to wait for News Server comm responses.
 * Thus in !ReviewMode, after an Initiate/EndSendSection, we give up control
 * and wvutil calls DoSend when ready to continue
 */
void
DoSend (int action)
{
  static unsigned long attachSentNumBytes;
  static BOOL MultipartMixed;
  char temp[MAXINTERNALLINE];
  static int abort, sectionNumInThisSend, nextState;
  unsigned long maxAttach;
  unsigned long offset;
  TypAttachment *thisAttach;

  if (action == ABORT || (!SendingMail && !SendingPost)) {
	abort = ABORT;
	AttachmentState = ATTACH_DONE;
  }

  while (AttachmentState != ATTACH_NONE) {
	switch (AttachmentState) {

	case ATTACH_START:
	  abort = ABORT;
	  MultipartMixed = FALSE;
	  currentCoded->numLines = 0;
	  currentCoded->numBytes = 0;
	  SentNumBytes = 0;
	  GenerateMIMEAttachmentID ();

	  if (ComposeWnd->attachment[0]->numBytes) {	// skip empty body

		SendAttachNum = 0;
	  }
	  else if (ComposeWnd->numAttachments > 1) {
		SendAttachNum = 1;
	  }
	  else {
		MessageBox (ComposeWnd->hWnd, "Nothing to send.", "Send Aborted", MB_OK | MB_ICONHAND);
		AttachmentState = ATTACH_DONE;
		break;
	  }

	  if (CalcNumParts (ComposeWnd) == FAIL)	// sets SendNumParts
	   {
		AttachmentState = ATTACH_DONE;
		break;
	  }

	  SendingPart = 1;
	  AttachmentState = ATTACH_START_NEXT_SEND;
	  nextState = ATTACH_BEGIN_ATTACHMENT;
	  // falls into next state

	case ATTACH_START_NEXT_SEND:
	  if (InitiateSend (ComposeWnd)) {
		AttachmentState = ATTACH_DONE;
		break;
	  }

	  ResetTextBlock (SectionHeader);
	  if (SendNumParts > 1 && GenerateMIME &&
		  GenerateMIMEPartialHeader (SectionHeader) == FAIL) {
		AttachmentState = ATTACH_DONE;
		break;
	  }

	  if (SendingPart == 1 && ComposeWnd->numAttachments > SendAttachNum + 1 && GenerateMIME) {
		MultipartMixed = TRUE;
		if (GenerateMIMEMultipartMixedHeader (SectionHeader)) {
		  AttachmentState = ATTACH_DONE;
		  break;
		}
	  }

	  AttachmentState = nextState;
	  sectionNumInThisSend = 0;
	  if (SendingPost) {
		return;					// waiting for post authorization

	  }
	  break;

	case ATTACH_BEGIN_ATTACHMENT:
	  thisAttach = ComposeWnd->attachment[SendAttachNum];	// convenient

	  attachSentNumBytes = 0;

	  if (SendAttachNum == 0) {	// status info

		strcpy (currentCoded->ident, "Body");
	  }
	  else {
		strcpy (currentCoded->ident, NameWithoutPath (str, thisAttach->fileName));
	  }
	  currentCoded->sequence = SendingPart;
//      currentCoded->numLines = 0;
	  //      currentCoded->numBytes = 0;
	  if (GenerateMIME) {
		GenerateMIMEContentHeader (SectionHeader, thisAttach);
	  }
	  AttachmentState = ATTACH_MAIN;
	  break;

	case ATTACH_MAIN:
	  thisAttach = ComposeWnd->attachment[SendAttachNum];	// convenient

	  if (SendingPost) {
		CommState = ST_POST_WAIT_END;
	  }
	  UpdateBlockStatus ();

	  if (!GenerateMIME && SendNumParts > 1) {
		if (AddEndedLineToTextBlock (SectionHeader, CUT_HERE_TEXT)) {
		  AttachmentState = ATTACH_DONE;
		  break;
		}
	  }

	  // if 1st section of a new send, then need to show main headers
	  if (sectionNumInThisSend == 0) {
		if (ComposeWnd->numAttachments > 1 || SendNumParts > 1) {
		  GenerateSubject (ComposeWnd);
		}
		SendTextBlock (MainHeader);
	  }
	  // send stuff prepared in START_NEXT_SEND/BEGIN_ATTACHMENT
	  SendTextBlock (SectionHeader);
	  ResetTextBlock (SectionHeader);

	  if (SendingPart == SendNumParts) {
		// add the rest of the attachment (this is the case for numParts == 1)
		maxAttach = 0;
	  }
	  else {
		maxAttach = ArticleSplitLength - SentNumBytes;
	  }
	  if (SendAttachNum == 0) {	// first attachment is body (from editWnd)

		if ((offset = SendPartialEditText (ComposeWnd->hWndEdit, attachSentNumBytes, maxAttach)) == 0) {
		  AttachmentState = ATTACH_DONE;
		  break;
		}
	  }
	  else {
		if (EncodingTypeToNum (thisAttach->encodingType) != CODE_NONE) {
		  if ((offset = EncodeAndSend (thisAttach, attachSentNumBytes, maxAttach)) == 0) {
			AttachmentState = ATTACH_DONE;
			break;
		  }
		}
		else {
		  if ((offset = SendPartialTextFile (thisAttach, attachSentNumBytes, maxAttach)) == 0) {
			AttachmentState = ATTACH_DONE;
			break;
		  }
		}
	  }
	  attachSentNumBytes += offset;

	  if (attachSentNumBytes < thisAttach->numBytes) {
		SendingPart++;
//          currentCoded->numLines = 0;
		currentCoded->sequence = SendingPart;	// status window info

		AttachmentState = ATTACH_START_NEXT_SEND;
		nextState = ATTACH_MAIN;

		if (EndSendSection (ComposeWnd) == FAIL) {
		  AttachmentState = ATTACH_DONE;
		  abort = ABORT;
		}
		else if (SendingPost)
		  return;
	  }
	  else						// Done with attachment
	   {
		if (SendAttachNum + 1 < ComposeWnd->numAttachments) {
		  if (GenerateMIME) {
			// we are multipart/mixed if we are here
			sprintf (temp, "--%s\r\n", MIMEBoundary);
			SendOneLine (temp);
		  }

		  SendAttachNum++;
		  if (ComposeWnd->attachment[SendAttachNum]->attachInNewArt) {
			SendingPart++;
			AttachmentState = ATTACH_START_NEXT_SEND;
			nextState = ATTACH_BEGIN_ATTACHMENT;
		  }
		  else {
			// begin new attachment in this same send
			sectionNumInThisSend++;
			AttachmentState = ATTACH_BEGIN_ATTACHMENT;
		  }
		}
		else {
		  // done with all attachments successfully
		  AttachmentState = ATTACH_DONE;
		  abort = CONTINUE;
		  if (GenerateMIME && MultipartMixed) {
			// if multi-part/mixed then need to attach final boundary
			sprintf (temp, "--%s--\r\n", MIMEBoundary);
			SendOneLine (temp);
		  }
		}
		if (AttachmentState != ATTACH_BEGIN_ATTACHMENT) {
		  if (EndSendSection (ComposeWnd) == FAIL) {
			AttachmentState = ATTACH_DONE;
			abort = ABORT;
		  }
		  else if (SendingPost)
			return;
		}
	  }
	  break;

	case ATTACH_DONE:
	  CompleteSend (ComposeWnd, abort);
	  AttachmentState = ATTACH_NONE;
	  break;

	}							// end of switch (AttachmentState)

  }								// end of while (AttachmentState != ATTACH_NONE)

  return;
}


/* ------------------------------------------------------------------------
 *    Send routines
 */
BOOL
InitiateSend (WndEdit * compWnd)
{
  int result = 0;

  CodingState = ATTACH_WAITING;
  UpdateBlockStatus ();

#ifdef ENABLE_COMM_SEND
  if (SendingMail) {
	if (compWnd->composeType == DOCTYPE_POSTING) {
	  result = prepare_cc_smtp_message (CcAddress, MainHeader);
	}
	else {
	  result = prepare_smtp_message (MainHeader);
	}
	if (result != 0) {
	  AbortSendMail (compWnd->hWnd);
	}
  }

  if (SendingPost) {
	result = 0;
	CommLinePtr = CommLineIn;
	CommBusy = TRUE;
	CommState = ST_POST_WAIT_PERMISSION;
	PutCommLine ("POST");
  }
#endif
  SentNumBytes = 0;
  return (result);
}

BOOL
EndSendSection (WndEdit * compWnd)
{
  int postResult, mailResult;
  postResult = mailResult = -1;	// default to failure

  CodingState = ATTACH_WAITING;
  UpdateBlockStatus ();

#ifdef ENABLE_COMM_SEND
  if (SendingMail) {
	mailResult = end_send_smtp ();
	if (mailResult != 0) {
	  AbortSendMail (compWnd->hWnd);
	}
  }
  if (SendingPost) {
	postResult = end_post ();
	if (postResult != 0) {
	  AbortSendPost (compWnd->hWnd);
	}
  }
#endif
  SentNumBytes = 0;
  // only return fail if _both_ failed
  return (mailResult && postResult) ? FAIL : SUCCESS;
}

void
CompleteSend (WndEdit * compWnd, int action)
{
  BOOL done = FALSE;

  EndLogging (compWnd->hWnd);

  FreeTextBlock (MainHeader);
  FreeTextBlock (SectionHeader);
  FreeTextBlock (WorkBlock);

  SetCursor (hSaveCursor);
  ReleaseCapture ();

  DestroyStatusArea ();
  CodingState = INACTIVE;
  ComposeWnd = (WndEdit *) NULL;

  if (action == CONTINUE) {
	/* if successful, close the compose window */
	DestroyWindow (compWnd->hWnd);

	/* if we're sending a batch, send the next */
	if (nextBatchIndex) {
	  BatchSend (compWnd->composeType);
	}
	else {
	  done = TRUE;
	}
  }
  else {
	/* unsuccessful, unset read-only bit to allow fixes, and allow send */
	SendMessage (compWnd->hWndEdit, EM_SETREADONLY, FALSE, 0L);
	EnableSendComposition (compWnd, TRUE);
	/* cancel any batch */
	nextBatchIndex = 0;
	done = TRUE;
  }
  if (SendingPost && done) {
	CommBusy = FALSE;
	CommState = ST_NONE;
  }
  if (CommDoc) {
	SetStatbarText (CommDoc->hWndFrame, "", CommDoc, TRUE, TRUE);
	InvalidateRect (CommDoc->hDocWnd, NULL, TRUE);
  }
  SetStatbarText (NetDoc.hWndFrame, "", &NetDoc, TRUE, TRUE);
  InvalidateRect (NetDoc.hDocWnd, NULL, TRUE);
  SendingMail = SendingPost = FALSE;
  compWnd->busy = FALSE;
}

BOOL
SendOneLineWithLen (char *str, unsigned long len)
{
  int postResult, mailResult;
  postResult = mailResult = -1;	// default to failure

#ifdef ENABLE_COMM_SEND
  if (SendingMail) {
	mailResult = send_smtp_line (str, len);
	if (mailResult != 0) {
	  AbortSendMail (ComposeWnd->hWnd);
	}
  }
  if (SendingPost) {
	postResult = post_line (str, len);
	if (postResult != 0) {
	  AbortSendPost (ComposeWnd->hWnd);
	}
  }
#endif
  SentNumBytes += len;
  currentCoded->numLines++;
  if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
	UpdateBlockStatus ();

  LogLine (ComposeWnd->hWnd, str, (unsigned int) len);

  // only return fail if _both_ failed
  return (mailResult && postResult) ? FAIL : SUCCESS;
}

BOOL
SendOneLine (char *str)
{
  return (SendOneLineWithLen (str, (unsigned long) strlen (str)));
}

BOOL
SendTextBlock (TypTextBlock * textBlock)
{
  register unsigned long i;
  unsigned long len;
  for (i = 0; i < textBlock->numLines; i++) {
	len = (unsigned long) strlen (TextBlockLine (textBlock, i));
	SendOneLineWithLen (TextBlockLine (textBlock, i), len);
	currentCoded->numBytes += len;
  }
  return SUCCESS;
}

unsigned long
SendPartialEditText (HWND hWnd, unsigned long startByte,
					 unsigned long maxBytes)
{
  unsigned long len, numBytes;
  char *text;
  char *ptr, *endPtr;
  int result = SUCCESS;

  CodingState = ATTACH_SENDING;

  if ((text = GetEditText (hWnd)) == NULL) {
	return 0L;
  }

  numBytes = 0L;
  ptr = &text[startByte];
  while (*ptr && result == SUCCESS && (!maxBytes || numBytes < maxBytes)) {
	if ((endPtr = strchr (ptr, '\r')) == NULL) {
	  /* last line didn't end with \r\n */
	  if ((result = SendOneLine (ptr)) == SUCCESS) {
		result = SendOneLineWithLen ("\r\n", 2);
	  }
	  numBytes += strlen (ptr) + 2;
	  break;
	}
	endPtr++;					/* move past \r */
	/* handle soft line break \r\r\n (see EM_FMTLINES) */
	if (*endPtr == '\r') {
	  *endPtr = '\n';
	}
	endPtr++;					/* move past \n */

	len = (unsigned long) (endPtr - ptr);
	result = SendOneLineWithLen (ptr, len);
	ptr = endPtr;
	numBytes += len;

	if (*ptr == '\n') {
	  ptr++;					/* move past extra \n (in case of soft line break extra \n */
	}
  }
  GlobalFreePtr (text);

  return numBytes;
}

BOOL
SendEditText (HWND hWnd)
{
  if (SendPartialEditText (hWnd, 0L, 0L) == 0L) {
	return FAIL;
  }
  else {
	return SUCCESS;
  }
}

unsigned long
SendPartialTextFile (TypAttachment * thisAttach, unsigned long startByte,
					 unsigned long maxBytes)
{
  HFILE hFile;
  int numRead;
  char inBuf[MAXOUTLINE];
  unsigned long totalNumRead;
  register int i;
  BOOL done;
  int result = SUCCESS;

  CodingState = ATTACH_READFILE;

  if ((hFile = _lopen (thisAttach->fileName, LOPEN_READ)) == HFILE_ERROR) {
	return (0);
  }
  if (startByte && _llseek (hFile, startByte, 0) == HFILE_ERROR) {
	_lclose (hFile);
	return (0);
  }
  done = FALSE;
  totalNumRead = 0L;
  while (!done && result == SUCCESS && (!maxBytes || totalNumRead < maxBytes)) {
	if ((numRead = _lread (hFile, inBuf, MAXOUTLINE)) == HFILE_ERROR) {
	  _lclose (hFile);
	  return (0);
	}
	if (numRead < MAXOUTLINE) {
	  done = TRUE;
	}
	else if (maxBytes && totalNumRead + numRead > maxBytes) {
	  // seek cr/lf
	  for (i = 0; i < numRead && !strchr ("\r\n", inBuf[i]); i++);
	  // skip over cr/lf's
	  for (; i < numRead && strchr ("\r\n", inBuf[i]); i++);
	  numRead = i;
	  done = TRUE;
	}
	totalNumRead += numRead;
	currentCoded->numBytes += numRead;
	currentCoded->numLines++;

	result = SendOneLineWithLen (inBuf, numRead);

	if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
	  UpdateBlockStatus ();
  }

  _lclose (hFile);

  UpdateBlockStatus ();
  return (totalNumRead);
}


/* ------------------------------------------------------------------------
 * Calculate the # parts needed for body and all attachments
 * This basically does a pre-flight of the entire send-generation process,
 * specifically paying attention to what headers will be generated, etc.
 * It's a bit clunky, and hard to maintain - since it must match the 
 * logic flow in the DoSend switch.  However, this _should_ give us
 * accurate NumParts _up front_ so we don't need to generate the full contents
 * in memory before sending it
 *
 */
BOOL
CalcNumParts (WndEdit * compWnd)
{
  register int i;
  unsigned long workSize, addSize, pSize, sizeLeft, offset;
  unsigned long aSize[MAX_NUM_ATTACHMENTS];
  BOOL msgBreak = FALSE;

  if (ArticleSplitLength == 0) {
	// just count # of attachInNewArt flags
	SendNumParts = 1;
	// if empty body, make first attachment act like the body
	i = (compWnd->attachment[0]->numBytes) ? 1 : 2;
	for (; i < compWnd->numAttachments; i++) {
	  if (compWnd->attachment[i]->attachInNewArt) {
		SendNumParts++;
	  }
	}
	return SUCCESS;
  }

  // generate an approximate subject line (only if it's obvious that
  // we'll need one)
  if (compWnd->numAttachments > 1 ||
	compWnd->attachment[0]->numBytes > (unsigned long) ArticleSplitLength) {
	SendingPart = SendNumParts = 20;	// dummy #s

	GenerateSubject (compWnd);
  }

  // calculate total number of bytes for all the body + attachments

  // body is attachment 0 
  aSize[0] = 0L;
  if (GenerateMIME && compWnd->numAttachments > 1 &&
	  compWnd->attachment[0]->numBytes > 0) {	// non-empty body

	ResetTextBlock (WorkBlock);
	if (GenerateMIMEMultipartMixedHeader (WorkBlock) == FAIL) {
	  return FAIL;
	}
	aSize[0] += WorkBlock->numBytes;
  }
  aSize[0] += compWnd->attachment[0]->numBytes;
  workSize = aSize[0];

  for (i = 1; i < compWnd->numAttachments; i++) {
	if (GenerateMIME) {
	  aSize[i] = WorkBlock->numBytes + strlen (MIMEBoundary) + 2;
	  ResetTextBlock (WorkBlock);
	  if (GenerateMIMEContentHeader (WorkBlock, compWnd->attachment[i]) == FAIL) {
		return FAIL;
	  }
	  aSize[i] += WorkBlock->numBytes;
	}
	else {
	  aSize[i] = strlen (CUT_HERE_TEXT);
	}
	if (EncodingTypeToNum (compWnd->attachment[i]->encodingType) != CODE_NONE) {
	  addSize = (compWnd->attachment[i]->numBytes * 4) / 3;
	  addSize += (addSize / 60) * 2;	// estimate \r\n for each line

	}
	else {
	  addSize = compWnd->attachment[i]->numBytes;
	}
	aSize[i] += addSize;
	workSize += aSize[i];
	if (compWnd->attachment[i]->attachInNewArt) {
	  msgBreak = TRUE;
	}
  }

  // if they all fit in one art, and the attachments were not broken by an
  // attachInNewArt flag, then done
  if (!msgBreak &&
	  workSize + MainHeader->numBytes < (unsigned long) ArticleSplitLength) {
	SendNumParts = 1;
	return SUCCESS;
  }

  // they don't all fit, or there was an attachInNewArt break, so do message/partial
  if (GenerateMIME) {
	ResetTextBlock (WorkBlock);
	GenerateMIMEPartialHeader (WorkBlock);
	pSize = WorkBlock->numBytes;
  }
  else {
	pSize = strlen (CUT_HERE_TEXT);
  }

  // calc number of bytes that will fit in each subsequent send (after headers)
  offset = ArticleSplitLength - MainHeader->numBytes - pSize;

  SendNumParts = 1;
  workSize = offset;			// space left in current art

  for (i = 0; i < compWnd->numAttachments; i++) {
	sizeLeft = aSize[i];

	while (sizeLeft > workSize) {	// sizeLeft - workSize > 0

	  sizeLeft -= workSize;
	  SendNumParts++;
	  workSize = offset;		// new article full-sized

	}
	// start new art with sizeLeft already used up
	if (i + 1 < compWnd->numAttachments) {
	  if (!compWnd->attachment[i + 1]->attachInNewArt) {
		workSize -= sizeLeft;
	  }
	  else {
		workSize = offset;
		SendNumParts++;
	  }
	}
  }
}

/* ------------------------------------------------------------------------
 *    MIME block generation routines
 */
BOOL
GenerateMIMEVersion (TypTextBlock * textBlock)
{
  char temp[MAXINTERNALLINE];

  sprintf (temp, "MIME-Version: %s", MIME_VERSION);
  return (AddEndedLineToTextBlock (textBlock, temp));
}

void
GenerateMIMEAttachmentID ()
{
  time_t theTime;

  time (&theTime);
  _snprintf (attachmentID, MAXINTERNALLINE, "\"%ld@@%s\"", theTime, UserName);
}

BOOL
GenerateMIMEMultipartMixedHeader (TypTextBlock * textBlock)
{
  char temp[MAXINTERNALLINE];

  if (AddEndedLineToTextBlock (textBlock, "Content-Type: multipart/mixed;"))
	return FAIL;

  sprintf (temp, "     Boundary=\"%s\"", MIMEBoundary);
  if (AddEndedLineToTextBlock (textBlock, temp))
	return FAIL;

  /* blank line to end headers */
  if (AddEndedLineToTextBlock (textBlock, ""))
	return FAIL;

  /* empty preamble here */
  sprintf (temp, "--%s", MIMEBoundary);
  if (AddEndedLineToTextBlock (textBlock, temp))
	return FAIL;
}

BOOL
GenerateMIMEPartialHeader (TypTextBlock * textBlock)
{
  char temp[MAXHEADERLINE];

  if (AddEndedLineToTextBlock (textBlock, "Content-Type: message/partial;"))
	return FAIL;

  _snprintf (temp, MAXHEADERLINE, "     id=%s;", attachmentID);
  if (AddEndedLineToTextBlock (textBlock, temp))
	return FAIL;

  _snprintf (temp, MAXHEADERLINE, "     number=%d; total=%d", SendingPart, SendNumParts);
  if (AddEndedLineToTextBlock (textBlock, temp))
	return FAIL;

  if (AddEndedLineToTextBlock (textBlock, ""))
	return FAIL;

  return SUCCESS;
}

BOOL
GenerateMIMEContentHeader (TypTextBlock * textBlock, TypAttachment * thisAttach)
{
  int type;
  register int i;
  char temp[MAXHEADERLINE], name[MAXFILENAME];

  for (i = 0; i < NUM_CONTENT_TYPES; i++)
	if (!_stricmp (thisAttach->contentType, ContentTypes[i]))
	  break;

  type = EncodingTypeToNum (thisAttach->encodingType);

  // if this is Text/Plain, non-encoded, don't need the Content-Type header
  if (!_stricmp (thisAttach->contentType, "Text/Plain") && type == CODE_NONE) {
	if (AddEndedLineToTextBlock (textBlock, ""))
	  return FAIL;

	return SUCCESS;
  }

  // note Text/Plain encoded gets turned into Application/octet-stream
  if (!_stricmp (thisAttach->contentType, "Other") || i == NUM_CONTENT_TYPES ||
	  !_stricmp (thisAttach->contentType, "Text/Plain")) {
	_snprintf (temp, MAXHEADERLINE, "Content-Type: Application/octet-stream; name=%s",
			   NameWithoutPath (name, thisAttach->fileName));
  }
  else {
	_snprintf (temp, MAXHEADERLINE, "Content-Type: %s", thisAttach->contentType);
  }

  if (AddEndedLineToTextBlock (textBlock, temp))
	return FAIL;

  switch (type) {
  case CODE_UU:
	_snprintf (temp, MAXHEADERLINE, "Content-Transfer-Encoding: %s", MIMEUUType);
	break;
  case CODE_XX:
	_snprintf (temp, MAXHEADERLINE, "Content-Transfer-Encoding: %s", MIMEXXType);
	break;
  case CODE_CUSTOM:
	_snprintf (temp, MAXHEADERLINE, "Content-Transfer-Encoding: %s", MIMECustomType);
	break;
  case CODE_BASE64:
	strcpy (temp, "Content-Transfer-Encoding: Base64");
	break;
  case CODE_NONE:
  default:
	*temp = '\0';
  }
  if (*temp && AddEndedLineToTextBlock (textBlock, temp))
	return FAIL;

  if (AddEndedLineToTextBlock (textBlock, ""))
	return FAIL;

  return SUCCESS;
}

/* ------------------------------------------------------------------------
 *    Generate a subject line based on orig subject line, and the
 *  subject template
 *      Replace %f with fileName
 *      Replace %p with part #
 *      Replace %0p with part # 0 padded to length of total # parts
 *      Replace %t with total # parts
 *      Replace %s with orig subject content
 *
 */
void
GenerateSubject (WndEdit * compWnd)
{
  register char *src, *dest, *ptr;
  register unsigned long num;
  char newSubject[MAXHEADERLINE];
  char numStr[10];
  int numZeros, part, numParts;
  extern char *NameWithoutPath ();

  strcpy (newSubject, "Subject: ");

  numParts = SendNumParts;
  part = SendingPart;

  // if non-empty body, and attachments exist, and first attachment starts 
  // in new art, then show count from zero instead of one.  (kinda kludgey!)
  if (compWnd->numAttachments > 1 && compWnd->attachment[0]->numBytes > 0 &&
	  compWnd->attachment[1]->attachInNewArt) {
	numParts--;
	part--;
  }

  for (src = SubjectTemplate, dest = &newSubject[9]; *src;) {
	if (*src == '%') {
	  src++;
	  switch (*src) {
	  case '%':				// literal percent is %%

		*dest++ = '%';
		break;
	  case 's':
		for (ptr = origSubject; *ptr; *dest++ = *ptr++);
		break;
	  case 'f':
		if (compWnd->numAttachments == 1) {
		  break;
		}
		else if (compWnd->numAttachments == 2) {
		  NameWithoutPath (str, compWnd->attachment[1]->fileName);
		}
		else {
		  _snprintf (str, MAXINTERNALLINE, "%d Attachments", compWnd->numAttachments - 1);
		}
		for (ptr = str; *ptr; *dest++ = *ptr++);
		break;

	  case '0':
		if (*(src + 1) == 'p') {
		  src++;				// skip zero
		  // zero-pad number to length of numParts string

		  itoa (numParts, numStr, 10);	// always length >= to part

		  itoa (part, str, 10);

		  for (numZeros = strlen (numStr) - strlen (str); numZeros; numZeros--)
			*dest++ = '0';

		  for (ptr = str; *ptr; *dest++ = *ptr++);
		}
		break;

	  case 'p':
		itoa (part, numStr, 10);
		for (ptr = numStr; *ptr; *dest++ = *ptr++);
		break;

	  case 't':
		itoa (numParts, numStr, 10);
		for (ptr = numStr; *ptr; *dest++ = *ptr++);
		break;

	  default:
		*dest++ = '%';
		*dest++ = *src;
		break;

	  }
	  src++;					// skip control char after %

	  continue;
	}
	*dest++ = *src++;
  }
  *dest = '\0';
  strcat (dest, "\r\n");

  /* find subject line in headers to replace */
  for (num = 0; num < MainHeader->numLines; num++)
	if (!_strnicmp (TextBlockLine (MainHeader, num), "subject:", 8))
	  break;

  ReplaceLineInTextBlock (MainHeader, num, newSubject);
}

/* ------------------------------------------------------------------------
 *    Directly modifies the Edit buffer of the given multi-line edit wnd
 *  Appends contents of fileName to buffer
 */
void
ReadTextFileIntoEditWnd (HWND hEditWnd, char *fileName)
{
  HFILE hFile;
  register unsigned int i;
  char *editBuf;
  unsigned int numRead;
  unsigned long size, expectedLen;

  expectedLen = GetFileLength (fileName);
  size = (unsigned long) SendMessage (hEditWnd, WM_GETTEXTLENGTH, 0, 0L);

  if (size + expectedLen > 60000L) {
	sprintf (str, "File %s is too large to read into the edit buffer.\nTry attaching it instead.", fileName);
	MessageBox (hEditWnd, str, "File Too Large", MB_OK | MB_ICONSTOP);
	return;
  }
  editBuf = (char *) GlobalAllocPtr (GMEM_MOVEABLE, expectedLen + 3);

  if ((hFile = _lopen (fileName, LOPEN_READ)) == HFILE_ERROR) {
	sprintf (str, "Could not open file %s for read", fileName);
	MessageBox (hEditWnd, str, "Open File Error", MB_OK);
	goto abortReadFile;
  }

  if ((numRead = _lread (hFile, editBuf, (unsigned int) expectedLen)) != expectedLen) {
	sprintf (str, "File %s not read correctly", fileName);
	MessageBox (hEditWnd, str, "File Read Error", MB_OK | MB_ICONSTOP);
	goto abortReadFile;
  }
  for (i = 0; i < numRead; i++)
	if (!__isascii (editBuf[i])) {
	  sprintf (str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
	  MessageBox (hEditWnd, str, "Non-ASCII File Error", MB_OK | MB_ICONSTOP);
	  _lclose (hFile);
	  goto abortReadFile;
	}
  _lclose (hFile);

  editBuf[numRead] = '\r';
  editBuf[numRead + 1] = '\n';
  editBuf[numRead + 2] = '\0';

  // insert at current position
  if (GetFocus () != hEditWnd) {
#ifdef _WIN32
	SendMessage (hEditWnd, EM_SETSEL, (WPARAM) (INT) size, (LPARAM) (INT) size);
#else
	SendMessage (hEditWnd, EM_SETSEL, (WPARAM) (UINT) 1, MAKELONG (size, size));
#endif
  }
  SendMessage (hEditWnd, EM_REPLACESEL, 0, (LPARAM) (LPCSTR) editBuf);

abortReadFile:
  GlobalFreePtr (editBuf);
}

#if 0
void
ReadTextFileIntoEditWnd (HWND hEditWnd, char *fileName)
{
  HFILE hFile;
  register unsigned int i;
  char *editBuf, *endPtr;
  unsigned int numRead;
  unsigned long size, expectedLen;

  if ((editBuf = GetEditText (hEditWnd)) == NULL)
	return;

  expectedLen = GetFileLength (fileName);
  size = strlen (editBuf) + expectedLen + 3;

  if (size > 60000L) {
	sprintf (str, "File %s is too large to read into the edit buffer.\nTry attaching it instead.", fileName);
	MessageBox (hEditWnd, str, "File Too Large", MB_OK | MB_ICONSTOP);
	goto abortReadFile;
  }
  editBuf = GlobalReAllocPtr (editBuf, size, GMEM_MOVEABLE);

  if ((hFile = _lopen (fileName, OF_READ)) == HFILE_ERROR) {
	sprintf (str, "Could not open file %s for read", fileName);
	MessageBox (hEditWnd, str, "Attachment Open File Error", MB_OK);
	return;
  }

  endPtr = editBuf + strlen (editBuf);

  if ((numRead = _lread (hFile, endPtr, (unsigned int) expectedLen)) != expectedLen) {
	sprintf (str, "File %s not read correctly", fileName);
	MessageBox (hEditWnd, str, "File Read Error", MB_OK | MB_ICONSTOP);
	goto abortReadFile;
  }
  for (i = 0; i < numRead; i++)
	if (!__isascii (endPtr[i])) {
	  sprintf (str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
	  MessageBox (hEditWnd, str, "Non-ASCII File Error", MB_OK | MB_ICONSTOP);
	  _lclose (hFile);
	  goto abortReadFile;
	}
  _lclose (hFile);
  endPtr[numRead] = '\r';
  endPtr[numRead + 1] = '\n';
  endPtr[numRead + 2] = '\0';

  SetEditText (hEditWnd, editBuf);

abortReadFile:
  GlobalFreePtr (editBuf);
}
#endif

#if OLD_HEADER
/* ------------------------------------------------------------------------
 * Returns true for lines which look like standard header lines
 * Returns non-zero if should skip this line, else zero
 * A binary search through a list of words would be really smart
 * Lazy approach
 */
int
TestRfc822HeaderLine (char *line)
{
  switch (tolower (line[0])) {
  case 'd':
	return (!_strnicmp (line, "date", 4));
  case 'f':
	return (!_strnicmp (line, "follow", 6) ||
			!_strnicmp (line, "from", 4));
  case 'k':
	return (!_strnicmp (line, "keywords", 8));

  case 'l':
	return (!_strnicmp (line, "lines", 5));
  case 'm':
	return (!_strnicmp (line, "message", 7));
  case 'n':
	return (!_strnicmp (line, "newsgrou", 8) ||
			!_strnicmp (line, "nntp", 4));
  case 'o':
	return (!_strnicmp (line, "organiza", 8) ||
			!_strnicmp (line, "originat", 8));
  case 'p':
	return (!_strnicmp (line, "path", 4));
  case 'r':
	return (!_strnicmp (line, "referenc", 8) ||
			!_strnicmp (line, "reply", 5));
  case 's':
	return (!_strnicmp (line, "sender", 6) ||
			!_strnicmp (line, "subject:", 8) ||
			!_strnicmp (line, "summary", 7));
  case 'x':
	return (!_strnicmp (line, "xref:", 5) ||
			!_strnicmp (line, "x-news", 6));
  default:
	return (0);
  }
}

#endif


#if 0
/* ------------------------------------------------------------------------
 * Calculate the # parts needed for this attachment
 * offset is the length of any headers/sections sent in this article, before 
 * this attachment
 */
void
CalcNumParts (unsigned long offset, TypAttachment * thisAttach)
{
  unsigned long workSize, cSize, pSize;

  if (!ArticleSplitLength) {
	thisAttach->numParts = 1;
	return;
  }

  // pre-flight the MIME stuff
  if (GenerateMIME) {
	GenerateMIMEAttachmentID ();

	ResetTextBlock (WorkBlock);
	GenerateMIMEContentHeader (WorkBlock, thisAttach);
	cSize = WorkBlock->numBytes;	// goes only in 1st send

	ResetTextBlock (WorkBlock);
	GenerateMIMEPartialHeader (WorkBlock, thisAttach);
	pSize = WorkBlock->numBytes;	// goes in all partial sends

  }
  else {
	cSize = pSize = 0;
//      pSize = strlen(CUT_HERE_TEXT);
  }
  // gen subject before calculating numParts      
  GenerateSubject (MainHeader, thisAttach, 1);	// dummy part num

  offset += cSize;

  // total size of encoded attachment 
  if (EncodingTypeToNum (thisAttach->encodingType) != CODE_NONE) {
	workSize = (thisAttach->numBytes * 4) / 3;
	workSize += (workSize / ENCODE_LINE_LEN) * 2;	// \r\n for each line

  }
  else {
	workSize = thisAttach->numBytes;
  }
  thisAttach->numParts = 1;
  if (workSize + offset > (unsigned long) ArticleSplitLength) {
	// total # attachment bytes to go after first send
	workSize -= (ArticleSplitLength - offset - pSize);

	// calc number of bytes from attachment that will fit in each subsequent send
	offset = ArticleSplitLength - MainHeader->numBytes - pSize;

	// how many more sends required after first for this attachment
	thisAttach->numParts += (int) ((workSize + offset) / offset);
  }
  return;
}
#endif
@


1.12
log
@reindented
@
text
@d17 1
d19 1
a19 32
 * $Id: wvsend.c 1.11 1994/11/09 23:02:21 rushing Exp rushing $
 * $Log: wvsend.c $
 * Revision 1.11  1994/11/09  23:02:21  rushing
 * 93.3 update
 *
 * Revision 1.10  1994/11/02  01:51:36  jcooper
 * lots of changes for .93.0
 * 
 * Revision 1.9  1994/09/16  00:57:09  jcooper
 * zero-padding in subject template, cleanup for 92.6
 * 
 * Revision 1.8  1994/08/24  17:59:26  jcooper
 * misc encoding/decoding changes
 *
 * Revision 1.7  1994/08/11  00:09:17  jcooper
 * Enhancements to Mime and article encoding/encoding
 *
 * Revision 1.6  1994/06/09  18:51:30  rushing
 * problem with symbol 'header' on AXP/NT
 *
 * Revision 1.5  1994/05/23  18:37:00  jcooper
 * new attach code, session [dis]connect
 *
 * Revision 1.3  1994/02/24  21:27:10  jcoop
 * jcoop changes
 *
 * Revision 1.2  1994/01/22  01:30:03  jcoop
 * 90.2 changes
 *
 * Revision 1.1  1994/01/16  12:10:08  jcoop
 * Initial revision
 *
d21 1
@


1.11
log
@93.3 update
@
text
@d18 1
a18 1
 * $Id: wvsend.c 1.10 1994/11/02 01:51:36 jcooper Exp $
d20 3
d50 1
a50 1
 */ 
d57 2
a58 2
#include <ctype.h>		/* for isspace, isalnum, etc */
#include <stdlib.h>		/* for itoa */
d63 18
a80 18
BOOL	InitiateSend (WndEdit *compWnd);
void	CompleteSend (WndEdit *compWnd, int action);
BOOL	EndSendSection (WndEdit *compWnd);

BOOL	GenerateMIMEVersion(TypTextBlock *header);
void	GenerateMIMEAttachmentID();
BOOL	GenerateMIMEMultipartMixedHeader (TypTextBlock *textBlock);
BOOL	GenerateMIMEPartialHeader(TypTextBlock *textBlock);
BOOL	GenerateMIMEContentHeader(TypTextBlock *textBlock, TypAttachment *thisAttach);
BOOL	CalcNumParts(WndEdit *compWnd);
void 	GenerateSubject(WndEdit *compWnd);

BOOL	SendOneLineWithLen(char *str, unsigned long len);
BOOL	SendOneLine(char *str);
BOOL 	SendTextBlock(TypTextBlock *textBlock);
BOOL	SendEditText(HWND hWnd);
unsigned long SendPartialEditText(HWND hWnd, unsigned long startByte, unsigned long maxBytes);
unsigned long SendPartialTextFile (TypAttachment *thisAttach, unsigned long startByte, unsigned long maxBytes);
d89 2
a90 1
char *EncodingTypes[] = { "Base-64", "UU", "XX", "Custom", "None" };
d93 16
a108 16
char *ContentTypes[] =  
    {	"Text/Plain",
		"Text/Richtext",
	    "Video/MPEG",
	    "Video/AVI",
	    "Image/JPEG",
	    "Image/GIF",
	    "Audio/Basic",
	    "Application/Zip",
	    "Application/PostScript",
	    "Other" };

#define ATTACH_NONE              0  /* state constants for DoSend */
#define ATTACH_START             1 	
#define ATTACH_FIRST_IN_THIS_WND 2	
#define ATTACH_FIRST_IN_NEXT_WND 3 
d118 1
a118 1
char origSubject[MAXHEADERLINE], attachmentID[MAXINTERNALLINE];	
d135 12
a146 12
	if (!stricmp (str, "Base-64"))
		return CODE_BASE64;
	else if (!stricmp (str, "UU"))
		return CODE_UU;
	else if (!stricmp (str, "XX"))
		return CODE_XX;
	else if (!stricmp (str, "Custom"))
		return CODE_CUSTOM;
	else if (!stricmp (str, "None"))
		return CODE_NONE;
	else
		return CODE_UNKNOWN;
d152 2
a153 22
void AbortMailLog(HWND hWnd)
{
	_snprintf(str, MAXINTERNALLINE, "Mail log error in file %s.  Logging disabled.", MailLogFile);
	MessageBox(hWnd, str, "Logging Error", MB_OK|MB_ICONINFORMATION);
	MailLog = FALSE;
	if (hMailLog) {
		_lclose(hMailLog);
		hMailLog = (HFILE)NULL;
	}
}
void AbortPostLog(HWND hWnd)
{
	_snprintf(str, MAXINTERNALLINE, "Post log error in file %s.  Logging disabled.", PostLogFile);
	MessageBox(hWnd, str, "Logging Error", MB_OK|MB_ICONINFORMATION);
	PostLog = FALSE;
	if (hPostLog) {
		_lclose(hPostLog);
		hPostLog = (HFILE)NULL;
	}
}

void LogLine(HWND hWnd, char *str, unsigned int len)
d155 134
a288 101
	if (SendingMail && MailLog && hMailLog) {
		if (_lwrite(hMailLog, str, len) == HFILE_ERROR) {
			AbortMailLog(hWnd);
		}
	}
	if (SendingPost && PostLog && hPostLog) {
		if (_lwrite(hPostLog, str, len) == HFILE_ERROR) {
			AbortPostLog(hWnd);
		}
	}
}

void InitLogging(HWND hWnd)
{
	OFSTRUCT ofs;
	char temp[MAXHEADERLINE], dateStr[MAXINTERNALLINE];
	int len;
	hMailLog = hPostLog = (HFILE)NULL;

	if (SendingPost && PostLog) {
		if (OpenFile(PostLogFile, &ofs, OF_EXIST) != HFILE_ERROR) {
			if ((hPostLog = OpenFile(PostLogFile, &ofs, OF_WRITE)) == HFILE_ERROR) {
				AbortPostLog(hWnd);
			} else {
				if (_llseek(hPostLog, 0L, 2) == HFILE_ERROR) {	/* seek eof */
					AbortPostLog(hWnd);
				}
			}
		} else {
			if ((hPostLog = OpenFile(PostLogFile, &ofs, OF_CREATE)) == HFILE_ERROR) {
				AbortPostLog(hWnd);
			}
		}		
	}
	
	// avoid logging mail if also logging post, and log files have same name
	if (SendingMail && MailLog && 
		(!SendingPost || !PostLog || strcmp(MailLogFile, PostLogFile))) {
		if (OpenFile(MailLogFile, &ofs, OF_EXIST) != HFILE_ERROR) {
			if ((hMailLog = OpenFile(MailLogFile, &ofs, OF_WRITE)) == HFILE_ERROR) {
				AbortMailLog(hWnd);
			} else {
				if (_llseek(hMailLog, 0L, 2) == HFILE_ERROR) {	/* seek eof */
					AbortMailLog(hWnd);
				}
			}
		} else {
			if ((hMailLog = OpenFile(MailLogFile, &ofs, OF_CREATE)) == HFILE_ERROR) {
				AbortMailLog(hWnd);
			}
		}		
	}

	/* add a mailbox header */
	if (hMailLog || hPostLog) {
		GetMailboxDate(dateStr, MAXINTERNALLINE-1);
		len = _snprintf(temp, MAXHEADERLINE, "From %s %s\r\n", 
			(*MailAddress) ? MailAddress : "Unknown", dateStr);
		LogLine(hWnd, temp, len);
	}
}

void EndLogging(HWND hWnd)
{
	/* add a blank line to the end */	
	LogLine(hWnd, "\r\n", 2);
	if (SendingMail && MailLog && hMailLog) {
		_lclose(hMailLog);
	}
	if (SendingPost && PostLog && hPostLog) {
		_lclose(hPostLog);
	}
	hMailLog = hPostLog = (HFILE)NULL;
}

void AbortSendMail(HWND hNotifyWnd)
{
	SendingMail = FALSE;
	if (SendingPost) {
		MessageBox(hNotifyWnd, "Mail has failed.  Post will continue.", "Mail Failure", MB_OK|MB_ICONINFORMATION);
	} else {
		MessageBox(hNotifyWnd, "Mail has failed.  Send aborted.", "Mail Failure", MB_OK|MB_ICONINFORMATION);
	}	
}

void AbortSendPost(HWND hNotifyWnd)
{
	SendingPost = FALSE;
	if (SendingMail) {
		MessageBox(hNotifyWnd, "Post has failed.  Mail will continue.", "Post Failure", MB_OK|MB_ICONINFORMATION);
	} else {
		MessageBox(hNotifyWnd, "Post has failed.  Send aborted.", "Post Failure", MB_OK|MB_ICONINFORMATION);
	}	
	CommBusy = FALSE;
	CommState = ST_NONE;
	SetStatbarText(NetDoc.hWndFrame, "", &NetDoc, TRUE, TRUE);
	InvalidateRect (NetDoc.hDocWnd, NULL, TRUE);
	if (CommDoc != &NetDoc) {
		SetStatbarText(CommDoc->hWndFrame, "", CommDoc, TRUE, TRUE);
		InvalidateRect (CommDoc->hDocWnd, NULL, TRUE);
	}
d294 2
a295 1
BOOL SendComposition(WndEdit *compWnd) 
d297 56
a352 51
	/* Initialize text blocks */
	if ((SectionHeader = InitTextBlock(compWnd->hWnd)) == NULL)
		return FAIL;
	if ((WorkBlock = InitTextBlock(compWnd->hWnd)) == NULL)
		return FAIL;
	if ((MainHeader = InitTextBlock(compWnd->hWnd)) == NULL)
		return FAIL;

	if (GenerateHeadersForSend(compWnd, MainHeader, origSubject) == FAIL)
		return FAIL;

	/* WinVN is stuck while sending -- this is released in CompleteSend */
	hSaveCursor = SetCursor(hHourGlass);
	SetCapture(compWnd->hWnd);

	SendingMail = 	compWnd->composeType == DOCTYPE_MAIL || 
					compWnd->composeType == DOCTYPE_FORWARD || 
					(compWnd->composeType == DOCTYPE_POSTING && *CcAddress);
	SendingPost =	compWnd->composeType == DOCTYPE_POSTING;
    
	InitLogging(compWnd->hWnd);

	/* init hCodedBlockWnd and currentCoded */
	CodingState = ATTACH_WAITING;	/* status info */
	CreateStatusArea (compWnd->hWnd, "Send Status", SW_SHOWNORMAL);
	InvalidateRect (hCodedBlockWnd, NULL, TRUE);	/* clear background */

	/* set body (attachment 0) size */
	compWnd->attachment[0]->numBytes = 
		(unsigned long)SendMessage (compWnd->hWndEdit, WM_GETTEXTLENGTH, 0, 0L);

	if (GenerateMIME) {
		if (GenerateMIMEVersion (MainHeader))
			{  CompleteSend (compWnd, ABORT); return FAIL;  }
	} else {
		if (AddEndedLineToTextBlock (MainHeader, ""))
			{  CompleteSend (compWnd, ABORT); return FAIL;  }
	}
  
	// we need this global since when wvutil.c calls DoSend, it doesn't
	// have a handle to the current compose window
    ComposeWnd = compWnd;
    compWnd->busy = TRUE;
    
	// lock out changes during send
	SendMessage(compWnd->hWndEdit, EM_SETREADONLY, TRUE, 0L);
	EnableSendComposition(compWnd, FALSE);

  	AttachmentState = ATTACH_START;
	DoSend (CONTINUE);
	return SUCCESS;
d361 1
a361 1
 */                         
d365 12
a376 12
	static unsigned long attachSentNumBytes;
	static BOOL MultipartMixed;
	char temp[MAXINTERNALLINE];
	static int abort, sectionNumInThisSend, nextState;
	unsigned long maxAttach;
	unsigned long offset;
	TypAttachment *thisAttach;
		
	if (action == ABORT || (!SendingMail && !SendingPost)) {
		abort = ABORT;
		AttachmentState = ATTACH_DONE;
	}
d382 30
a411 24
		abort = ABORT;
		MultipartMixed = FALSE;
		currentCoded->numLines = 0;
		currentCoded->numBytes = 0;
		SentNumBytes = 0;
		GenerateMIMEAttachmentID();
		
		if (ComposeWnd->attachment[0]->numBytes) {	// skip empty body
			SendAttachNum = 0;
		} else if (ComposeWnd->numAttachments > 1) {
			SendAttachNum = 1;
		} else {
			MessageBox(ComposeWnd->hWnd, "Nothing to send.", "Send Aborted",  MB_OK|MB_ICONHAND);
			AttachmentState = ATTACH_DONE; 
			break;  
		}
		
		if (CalcNumParts(ComposeWnd) == FAIL)   // sets SendNumParts
			{  AttachmentState = ATTACH_DONE; break;  }
		
       	SendingPart = 1;
		AttachmentState = ATTACH_START_NEXT_SEND;
		nextState = ATTACH_BEGIN_ATTACHMENT;
		// falls into next state
d414 4
a417 2
		if (InitiateSend (ComposeWnd))
			{  AttachmentState = ATTACH_DONE; break;  }
d419 4
a422 16
		ResetTextBlock(SectionHeader);
		if (SendNumParts > 1 && GenerateMIME &&
			GenerateMIMEPartialHeader(SectionHeader) == FAIL)
			{  AttachmentState = ATTACH_DONE; break;  }
			
		if (SendingPart == 1 && ComposeWnd->numAttachments > SendAttachNum+1 && GenerateMIME) {
			MultipartMixed = TRUE;
			if (GenerateMIMEMultipartMixedHeader (SectionHeader))
	  			{  AttachmentState = ATTACH_DONE; break;  }
	  	}

		AttachmentState = nextState;
		sectionNumInThisSend = 0;
		if (SendingPost) {
    		return;		// waiting for post authorization
    	}
d424 17
d443 3
a445 2
		thisAttach = ComposeWnd->attachment[SendAttachNum];	// convenient
		attachSentNumBytes = 0;
d447 15
a461 13
		if (SendAttachNum == 0) {		// status info
			strcpy (currentCoded->ident, "Body");
		} else {		
			strcpy (currentCoded->ident, NameWithoutPath(str, thisAttach->fileName));
		}
		currentCoded->sequence = SendingPart;
//		currentCoded->numLines = 0;
//		currentCoded->numBytes = 0;
		if (GenerateMIME) {
			GenerateMIMEContentHeader(SectionHeader, thisAttach);
		}		
		AttachmentState = ATTACH_MAIN;
		break;
d464 45
a508 3
		thisAttach = ComposeWnd->attachment[SendAttachNum];	// convenient
		if (SendingPost) {
			CommState = ST_POST_WAIT_END;
d510 13
a522 1
		UpdateBlockStatus();
d524 2
a525 4
		if (!GenerateMIME && SendNumParts > 1) {
			if (AddEndedLineToTextBlock (SectionHeader, CUT_HERE_TEXT))
				{  AttachmentState = ATTACH_DONE; break;  }
		}
d527 15
a541 30
		// if 1st section of a new send, then need to show main headers
		if (sectionNumInThisSend == 0) {
			if (ComposeWnd->numAttachments > 1 || SendNumParts > 1) {
				GenerateSubject (ComposeWnd);
			}
			SendTextBlock (MainHeader);
		}
		// send stuff prepared in START_NEXT_SEND/BEGIN_ATTACHMENT
		SendTextBlock(SectionHeader);
		ResetTextBlock(SectionHeader);

		if (SendingPart == SendNumParts) {
			// add the rest of the attachment (this is the case for numParts == 1)
			maxAttach = 0;	
		} else {
			maxAttach = ArticleSplitLength - SentNumBytes;
		}
		if (SendAttachNum == 0) {	// first attachment is body (from editWnd)
			if ((offset = SendPartialEditText(ComposeWnd->hWndEdit, attachSentNumBytes, maxAttach)) == 0)
				{  AttachmentState = ATTACH_DONE; break;  }
		} else {
			if (EncodingTypeToNum(thisAttach->encodingType) != CODE_NONE) {
				if ((offset = EncodeAndSend(thisAttach, attachSentNumBytes, maxAttach)) == 0)
					{  AttachmentState = ATTACH_DONE; break;  }
			} else {
				if ((offset = SendPartialTextFile(thisAttach, attachSentNumBytes, maxAttach)) == 0)
					{  AttachmentState = ATTACH_DONE; break;  }
			}
		}
		attachSentNumBytes += offset;
d543 2
a544 2
		if (attachSentNumBytes < thisAttach->numBytes) 
		{
a545 3
//			currentCoded->numLines = 0;
			currentCoded->sequence = SendingPart;	// status window info

d547 25
a571 44
			nextState = ATTACH_MAIN;

			if (EndSendSection (ComposeWnd) == FAIL) {
				AttachmentState = ATTACH_DONE;
				abort = ABORT;
			} else if (SendingPost)
				return;
		}
		else // Done with attachment
		{	
			if (SendAttachNum + 1 < ComposeWnd->numAttachments) {
				if (GenerateMIME) {
					// we are multipart/mixed if we are here
					sprintf (temp, "--%s\r\n", MIMEBoundary);
					SendOneLine(temp);
				}

				SendAttachNum++;
				if (ComposeWnd->attachment[SendAttachNum]->attachInNewArt) {
					SendingPart++;
					AttachmentState = ATTACH_START_NEXT_SEND;
					nextState = ATTACH_BEGIN_ATTACHMENT;
				} else {
					// begin new attachment in this same send
					sectionNumInThisSend++;
					AttachmentState = ATTACH_BEGIN_ATTACHMENT;
				}
			} else {	
				// done with all attachments successfully
				AttachmentState = ATTACH_DONE;
				abort = CONTINUE;
				if (GenerateMIME && MultipartMixed) {
					// if multi-part/mixed then need to attach final boundary
					sprintf (temp, "--%s--\r\n", MIMEBoundary);
					SendOneLine(temp);
				}	
			}
			if (AttachmentState != ATTACH_BEGIN_ATTACHMENT) {
				if (EndSendSection (ComposeWnd) == FAIL) {
					AttachmentState = ATTACH_DONE;
					abort = ABORT;
				} else if (SendingPost)
					return;
			}
d573 2
a574 1
		break;
d577 8
a584 7
		CompleteSend (ComposeWnd, abort); 
		AttachmentState = ATTACH_NONE;
		break;
	
	} // end of switch (AttachmentState)
  
  } // end of while (AttachmentState != ATTACH_NONE)
d590 1
a590 1
 *	Send routines
d593 1
a593 1
InitiateSend (WndEdit *compWnd)
d595 1
a595 1
	int result = 0;
d597 2
a598 2
	CodingState = ATTACH_WAITING;
	UpdateBlockStatus();
d601 19
a619 18
	if (SendingMail) {
		if (compWnd->composeType == DOCTYPE_POSTING) {
			result = prepare_cc_smtp_message (CcAddress, MainHeader);
		} else {
			result = prepare_smtp_message (MainHeader);
		}
		if (result != 0) {
			AbortSendMail(compWnd->hWnd);
		}
	}
	
	if (SendingPost) {
		result = 0;
		CommLinePtr = CommLineIn;
		CommBusy = TRUE;
		CommState = ST_POST_WAIT_PERMISSION;
		PutCommLine ("POST");
	}
d621 2
a622 2
	SentNumBytes = 0;
	return (result);
d626 1
a626 1
EndSendSection (WndEdit *compWnd)
d628 6
a633 6
	int postResult, mailResult;
	postResult = mailResult = -1;	// default to failure
	
	CodingState = ATTACH_WAITING;
	UpdateBlockStatus();
	
d635 10
a644 5
	if (SendingMail) {
		mailResult = end_send_smtp();
		if (mailResult != 0) {
			AbortSendMail(compWnd->hWnd);
		}
d646 1
a646 6
	if (SendingPost) {
		postResult = end_post();
		if (postResult != 0) {
			AbortSendPost(compWnd->hWnd);
		}
	}	
d648 3
a650 3
	SentNumBytes = 0;
	// only return fail if _both_ failed
	return (mailResult && postResult) ? FAIL : SUCCESS;
d654 1
a654 1
CompleteSend (WndEdit *compWnd, int action)
d656 47
a702 45
	BOOL done = FALSE;
	
	EndLogging(compWnd->hWnd);
	
	FreeTextBlock (MainHeader);
	FreeTextBlock (SectionHeader);
	FreeTextBlock (WorkBlock);
	
	SetCursor(hSaveCursor);
	ReleaseCapture();

	DestroyStatusArea();
	CodingState = INACTIVE;
	ComposeWnd = (WndEdit *)NULL;
	
	if (action == CONTINUE) {
		/* if successful, close the compose window */
		DestroyWindow (compWnd->hWnd);
		
		/* if we're sending a batch, send the next */
		if (nextBatchIndex) {
			BatchSend (compWnd->composeType);
		} else {
			done = TRUE;
		}		
	} else {	
		/* unsuccessful, unset read-only bit to allow fixes, and allow send */
		SendMessage(compWnd->hWndEdit, EM_SETREADONLY, FALSE, 0L);	
		EnableSendComposition(compWnd, TRUE);
		/* cancel any batch */
		nextBatchIndex = 0; 
		done = TRUE;
	}
	if (SendingPost && done) {
		CommBusy = FALSE;
		CommState = ST_NONE;
	}
	if (CommDoc) {
		SetStatbarText(CommDoc->hWndFrame, "", CommDoc, TRUE, TRUE);
		InvalidateRect (CommDoc->hDocWnd, NULL, TRUE);
	}
	SetStatbarText(NetDoc.hWndFrame, "", &NetDoc, TRUE, TRUE);
	InvalidateRect (NetDoc.hDocWnd, NULL, TRUE);
	SendingMail = SendingPost = FALSE;
    compWnd->busy = FALSE;
d706 1
a706 1
SendOneLineWithLen(char *str, unsigned long len)
d708 3
a710 3
	int postResult, mailResult;
	postResult = mailResult = -1;	// default to failure
	
d712 10
a721 5
	if (SendingMail) {
		mailResult = send_smtp_line(str, len);
		if (mailResult != 0) {
			AbortSendMail(ComposeWnd->hWnd);
		}
d723 1
a723 6
	if (SendingPost) {
		postResult = post_line(str, len);
		if (postResult != 0) {
			AbortSendPost(ComposeWnd->hWnd);
		}
	}	
d725 9
a733 9
	SentNumBytes += len;
	currentCoded->numLines++;
	if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
		UpdateBlockStatus ();
	
	LogLine(ComposeWnd->hWnd, str, (unsigned int)len);	
	
	// only return fail if _both_ failed
	return (mailResult && postResult) ? FAIL : SUCCESS;
d736 2
a737 2
BOOL 
SendOneLine(char *str)
d739 1
a739 1
	return (SendOneLineWithLen(str, (unsigned long)strlen(str)));
d743 1
a743 1
SendTextBlock(TypTextBlock *textBlock)
d745 50
a794 6
	register unsigned long i;
	unsigned long len;	
	for (i = 0; i < textBlock->numLines; i++) {
		len = (unsigned long)strlen(TextBlockLine(textBlock, i));
		SendOneLineWithLen(TextBlockLine(textBlock, i), len);
		currentCoded->numBytes += len;
d796 2
a797 46
	return SUCCESS;
}

unsigned long 
SendPartialEditText(HWND hWnd, unsigned long startByte, 
				unsigned long maxBytes)
{
	unsigned long len, numBytes;
	char *text;
	char *ptr, *endPtr;
	int result = SUCCESS;

	CodingState = ATTACH_SENDING;

	if ((text = GetEditText(hWnd)) == NULL) {
		return 0L;
	}
	
	numBytes = 0L;
    ptr = &text[startByte];
    while (*ptr && result == SUCCESS && (!maxBytes || numBytes < maxBytes)) {
    	if ((endPtr = strchr(ptr, '\r')) == NULL) {
    		/* last line didn't end with \r\n */
    		if ((result = SendOneLine(ptr)) == SUCCESS) {
    			result = SendOneLineWithLen("\r\n", 2);
    		}
    		numBytes += strlen(ptr) + 2;
    		break;
    	}
    	endPtr++;	/* move past \r */
    	/* handle soft line break \r\r\n (see EM_FMTLINES) */
    	if (*endPtr == '\r') {
    		*endPtr = '\n';
    	}
    	endPtr++;	/* move past \n */

    	len = (unsigned long)(endPtr - ptr);
    	result = SendOneLineWithLen(ptr, len);
    	ptr = endPtr;
    	numBytes += len;
    	
    	if (*ptr == '\n') {
    		ptr++;	/* move past extra \n (in case of soft line break extra \n */
    	}
    }
    GlobalFreePtr(text);
d799 1
a799 1
	return numBytes;
d803 1
a803 1
SendEditText(HWND hWnd)
d805 6
a810 5
	if (SendPartialEditText(hWnd, 0L, 0L) == 0L) {
		return FAIL;
	} else {
		return SUCCESS;
	}
d813 18
a830 48
unsigned long 
SendPartialTextFile (TypAttachment *thisAttach, unsigned long startByte, 
		unsigned long maxBytes)
{
	HFILE hFile;
	int numRead;
	char inBuf[MAXOUTLINE];
	unsigned long totalNumRead;
	register int i;
	BOOL done;
	int result = SUCCESS;
	    
	CodingState = ATTACH_READFILE;

	if ((hFile = _lopen (thisAttach->fileName, LOPEN_READ)) == HFILE_ERROR) {
		return(0);
	}
	if (startByte && _llseek (hFile, startByte, 0) == HFILE_ERROR) {
		_lclose (hFile);
		return(0);
	}
	done = FALSE;
	totalNumRead = 0L;
	while (!done && result == SUCCESS && (!maxBytes || totalNumRead < maxBytes)) {
		if ((numRead = _lread(hFile, inBuf, MAXOUTLINE)) == HFILE_ERROR) {
			_lclose (hFile);
			return(0);
		}
		if (numRead < MAXOUTLINE) {
			done = TRUE;
		} else if (maxBytes && totalNumRead + numRead > maxBytes) {
			// seek cr/lf
			for (i = 0; i < numRead && !strchr("\r\n", inBuf[i]); i++);
			// skip over cr/lf's
			for (; i < numRead && strchr("\r\n", inBuf[i]); i++);
			numRead = i;   
			done = TRUE;
		}			
		totalNumRead += numRead;
		currentCoded->numBytes += numRead;
		currentCoded->numLines++;

    	result = SendOneLineWithLen(inBuf, numRead);

		if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
			UpdateBlockStatus ();
	}    	
	
d832 31
d864 2
a865 2
	UpdateBlockStatus ();
	return (totalNumRead);
d867 1
a867 1
	
d880 1
a880 1
CalcNumParts(WndEdit *compWnd)
d882 51
a932 16
	register int i;
	unsigned long workSize, addSize, pSize, sizeLeft, offset;
	unsigned long aSize[MAX_NUM_ATTACHMENTS];
	BOOL msgBreak = FALSE;

	if (ArticleSplitLength == 0) {
		// just count # of attachInNewArt flags
		SendNumParts = 1;
		// if empty body, make first attachment act like the body
		i = (compWnd->attachment[0]->numBytes) ? 1 : 2;
		for (; i < compWnd->numAttachments; i++) {
			if (compWnd->attachment[i]->attachInNewArt) {
				SendNumParts++;
			}
		}
		return SUCCESS;
d934 2
a935 20
			
	// generate an approximate subject line (only if it's obvious that
	// we'll need one)
	if (compWnd->numAttachments > 1 || 
		compWnd->attachment[0]->numBytes > (unsigned long)ArticleSplitLength) {
		SendingPart = SendNumParts = 20;	// dummy #s
		GenerateSubject(compWnd);
	}	
	
	// calculate total number of bytes for all the body + attachments

	// body is attachment 0	
	aSize[0] = 0L;
	if (GenerateMIME && compWnd->numAttachments > 1 && 
		compWnd->attachment[0]->numBytes > 0) {	// non-empty body
		ResetTextBlock(WorkBlock);
		if (GenerateMIMEMultipartMixedHeader (WorkBlock) == FAIL) {
			return FAIL;
		}
		aSize[0] += WorkBlock->numBytes;
d937 4
a940 25
	aSize[0] += compWnd->attachment[0]->numBytes;
	workSize = aSize[0];
	
	for (i = 1; i < compWnd->numAttachments; i++) {
		if (GenerateMIME) {
			aSize[i] = WorkBlock->numBytes + strlen(MIMEBoundary) + 2;
			ResetTextBlock(WorkBlock);
			if (GenerateMIMEContentHeader (WorkBlock, compWnd->attachment[i]) == FAIL) {
				return FAIL;
			}
			aSize[i] += WorkBlock->numBytes;
		} else {
			aSize[i] = strlen(CUT_HERE_TEXT);
		}
		if (EncodingTypeToNum(compWnd->attachment[i]->encodingType) != CODE_NONE) {
			addSize = (compWnd->attachment[i]->numBytes * 4)/3;
			addSize += (addSize/60)*2;		// estimate \r\n for each line
		} else {
			addSize = compWnd->attachment[i]->numBytes;
		} 
		aSize[i] += addSize;
		workSize += aSize[i];
		if (compWnd->attachment[i]->attachInNewArt) {
			msgBreak = TRUE;
		}
d942 2
a943 7
	
	// if they all fit in one art, and the attachments were not broken by an
	// attachInNewArt flag, then done
	if (!msgBreak && 
		workSize + MainHeader->numBytes < (unsigned long)ArticleSplitLength) {
		SendNumParts = 1;
		return SUCCESS;
d945 4
a948 8

	// they don't all fit, or there was an attachInNewArt break, so do message/partial
	if (GenerateMIME) {
		ResetTextBlock(WorkBlock);
		GenerateMIMEPartialHeader(WorkBlock);
		pSize = WorkBlock->numBytes;
	} else {
		pSize = strlen(CUT_HERE_TEXT);
d950 1
d952 4
a955 3
	// calc number of bytes that will fit in each subsequent send (after headers)
	offset = ArticleSplitLength - MainHeader->numBytes - pSize;
	
d957 40
a996 20
    workSize = offset;	// space left in current art
 
    for (i = 0; i < compWnd->numAttachments; i++) {
		sizeLeft = aSize[i];

		while (sizeLeft > workSize) {	// sizeLeft - workSize > 0
			sizeLeft -= workSize;
			SendNumParts++;
			workSize = offset;	// new article full-sized
		}
		// start new art with sizeLeft already used up
		if (i + 1 < compWnd->numAttachments) {
			if (!compWnd->attachment[i+1]->attachInNewArt) {
				workSize -= sizeLeft;
			} else {
				workSize = offset;
				SendNumParts++;
			}		
		}
    }
d1000 1
a1000 1
 *	MIME block generation routines
d1003 1
a1003 1
GenerateMIMEVersion (TypTextBlock *textBlock)
d1005 4
a1008 4
	char temp[MAXINTERNALLINE];
	
	sprintf (temp, "MIME-Version: %s", MIME_VERSION);
	return (AddEndedLineToTextBlock (textBlock, temp));
d1012 1
a1012 1
GenerateMIMEAttachmentID()
d1014 1
a1014 1
	time_t theTime;
d1016 2
a1017 2
	time (&theTime);
	_snprintf (attachmentID, MAXINTERNALLINE, "\"%ld@@%s\"", theTime, UserName);
d1021 1
a1021 1
GenerateMIMEMultipartMixedHeader (TypTextBlock *textBlock)
d1023 4
a1026 1
	char temp[MAXINTERNALLINE];
d1028 7
a1034 10
	if (AddEndedLineToTextBlock (textBlock, "Content-Type: multipart/mixed;"))
		return FAIL;
	
	sprintf (temp, "     Boundary=\"%s\"", MIMEBoundary);
	if (AddEndedLineToTextBlock (textBlock, temp))
		return FAIL;
			  
	/* blank line to end headers */
	if (AddEndedLineToTextBlock (textBlock, ""))
		return FAIL;
d1036 5
a1040 5
	/* empty preamble here */
	sprintf (temp, "--%s", MIMEBoundary);
	if (AddEndedLineToTextBlock (textBlock, temp))
		return FAIL;
}                  
d1043 1
a1043 1
GenerateMIMEPartialHeader(TypTextBlock *textBlock)
d1045 1
a1045 1
	char temp[MAXHEADERLINE];
d1047 6
a1052 2
	if (AddEndedLineToTextBlock (textBlock, "Content-Type: message/partial;"))
		return FAIL;
d1054 3
a1056 3
	_snprintf (temp, MAXHEADERLINE, "     id=%s;", attachmentID);
	if (AddEndedLineToTextBlock (textBlock, temp))
		return FAIL;
d1058 2
a1059 6
	_snprintf (temp, MAXHEADERLINE, "     number=%d; total=%d", SendingPart, SendNumParts);
	if (AddEndedLineToTextBlock (textBlock, temp))
		return FAIL;
		    
	if (AddEndedLineToTextBlock (textBlock, ""))
		return FAIL;
d1061 1
a1061 1
	return SUCCESS;
d1065 1
a1065 1
GenerateMIMEContentHeader(TypTextBlock *textBlock, TypAttachment *thisAttach)
d1067 9
a1075 9
	int type;
	register int i;
	char temp[MAXHEADERLINE], name[MAXFILENAME];
	
	for (i = 0; i < NUM_CONTENT_TYPES; i++)
		if (!_stricmp (thisAttach->contentType, ContentTypes[i]))
			break;
	
	type = EncodingTypeToNum(thisAttach->encodingType);	
d1077 2
a1078 41
	// if this is Text/Plain, non-encoded, don't need the Content-Type header
	if (!_stricmp (thisAttach->contentType, "Text/Plain") && type == CODE_NONE) {
		if (AddEndedLineToTextBlock (textBlock, ""))
			return FAIL;
		
		return SUCCESS;
	}			

	// note Text/Plain encoded gets turned into Application/octet-stream
	if (!_stricmp (thisAttach->contentType, "Other") || i == NUM_CONTENT_TYPES ||
		!_stricmp (thisAttach->contentType, "Text/Plain")) {
		_snprintf (temp, MAXHEADERLINE, "Content-Type: Application/octet-stream; name=%s", 
					NameWithoutPath (name, thisAttach->fileName));
	} else {
		_snprintf (temp, MAXHEADERLINE, "Content-Type: %s", thisAttach->contentType);
	}
		
	if (AddEndedLineToTextBlock (textBlock, temp))
		return FAIL;
					         
	switch (type)
	{
	case CODE_UU:	
		_snprintf (temp, MAXHEADERLINE, "Content-Transfer-Encoding: %s", MIMEUUType);
		break;
	case CODE_XX:
		_snprintf (temp, MAXHEADERLINE, "Content-Transfer-Encoding: %s", MIMEXXType);
		break;
	case CODE_CUSTOM:
		_snprintf (temp, MAXHEADERLINE, "Content-Transfer-Encoding: %s", MIMECustomType);
		break;
	case CODE_BASE64:
		strcpy (temp, "Content-Transfer-Encoding: Base64");
		break;
	case CODE_NONE:
	default:
		*temp = '\0';
	}
	if (*temp && AddEndedLineToTextBlock (textBlock, temp))
		return FAIL;
		
d1080 1
a1080 1
		return FAIL;
d1083 39
d1125 7
a1131 7
 *	Generate a subject line based on orig subject line, and the
 * 	subject template
 *		Replace %f with fileName
 *		Replace %p with part #
 *		Replace %0p with part # 0 padded to length of total # parts
 *		Replace %t with total # parts
 *		Replace %s with orig subject content
d1135 1
a1135 1
GenerateSubject (WndEdit *compWnd)
d1137 37
a1173 77
	register char *src, *dest, *ptr;
	register unsigned long num;
	char newSubject[MAXHEADERLINE];
	char numStr[10];
	int numZeros, part, numParts;
	extern char *NameWithoutPath ();

	strcpy(newSubject, "Subject: ");

	numParts = SendNumParts;
	part = SendingPart;
	
	// if non-empty body, and attachments exist, and first attachment starts 
	// in new art, then show count from zero instead of one.  (kinda kludgey!)
	if (compWnd->numAttachments > 1 && compWnd->attachment[0]->numBytes > 0 &&
		compWnd->attachment[1]->attachInNewArt) {
		numParts--;
		part--;
	}

	for (src = SubjectTemplate, dest = &newSubject[9]; *src;)
	{
		if (*src == '%')
		{
			src++;
			switch (*src)
			{
			case '%':		// literal percent is %%
				*dest++ = '%';
				break;
			case 's':
				for (ptr = origSubject; *ptr; *dest++ = *ptr++);
				break;
			case 'f':
				if (compWnd->numAttachments == 1) {
					break;
				} else if (compWnd->numAttachments == 2) {
					NameWithoutPath (str, compWnd->attachment[1]->fileName);
				} else {
					_snprintf (str, MAXINTERNALLINE, "%d Attachments", compWnd->numAttachments-1);
				}
				for (ptr = str; *ptr; *dest++ = *ptr++);
				break;

			case '0':
				if (*(src+1) == 'p')
				{
					src++;	// skip zero
					// zero-pad number to length of numParts string
					itoa (numParts, numStr, 10);	// always length >= to part
					itoa (part, str, 10);
					
					for (numZeros = strlen(numStr) - strlen(str); numZeros; numZeros--)
						*dest++ = '0';
					
					for (ptr = str; *ptr; *dest++ = *ptr++);
				}
				break;
				
			case 'p':
				itoa (part, numStr, 10);
				for (ptr = numStr; *ptr; *dest++ = *ptr++);
				break;

			case 't':
				itoa (numParts, numStr, 10);
				for (ptr = numStr; *ptr; *dest++ = *ptr++);
				break;

			default:
				*dest++ = '%';
				*dest++ = *src;
				break;

			}
			src++;	// skip control char after %
			continue;
d1175 41
a1215 1
		*dest++ = *src++;	
d1217 9
a1225 2
	*dest = '\0';   
	strcat (dest, "\r\n");
d1227 1
a1227 6
	/* find subject line in headers to replace */
	for (num = 0; num < MainHeader->numLines; num++)
		if (!_strnicmp (TextBlockLine (MainHeader, num), "subject:", 8))
			break;
	
	ReplaceLineInTextBlock (MainHeader, num, newSubject);
d1231 2
a1232 2
 * 	Directly modifies the Edit buffer of the given multi-line edit wnd
 *	Appends contents of fileName to buffer
d1237 39
a1275 42
	HFILE hFile;
	register unsigned int i;
	char *editBuf;
	unsigned int numRead;
	unsigned long size, expectedLen;

	expectedLen = GetFileLength(fileName);
	size = (unsigned long) SendMessage (hEditWnd, WM_GETTEXTLENGTH, 0, 0L);

	if (size + expectedLen > 60000L) {
		sprintf(str, "File %s is too large to read into the edit buffer.\nTry attaching it instead.", fileName);
		MessageBox (hEditWnd, str, "File Too Large", MB_OK|MB_ICONSTOP);
		return;
	}		
	editBuf = (char *)GlobalAllocPtr (GMEM_MOVEABLE, expectedLen+3);
		
	if ((hFile = _lopen (fileName, LOPEN_READ)) == HFILE_ERROR)
	{
		sprintf(str, "Could not open file %s for read", fileName);
		MessageBox (hEditWnd, str, "Open File Error", MB_OK);
		goto abortReadFile;
	}
	
	if ((numRead = _lread(hFile, editBuf, (unsigned int)expectedLen)) != expectedLen)
	{
		sprintf(str, "File %s not read correctly", fileName);
		MessageBox (hEditWnd, str, "File Read Error", MB_OK|MB_ICONSTOP);
		goto abortReadFile;
	}
	for (i = 0; i < numRead; i++) 
		if (!__isascii (editBuf[i]))
		{
			sprintf(str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
			MessageBox (hEditWnd, str, "Non-ASCII File Error", MB_OK|MB_ICONSTOP);
			_lclose(hFile);
			goto abortReadFile;
		}
	_lclose(hFile);
	
	editBuf[numRead]='\r';
	editBuf[numRead+1]='\n';
	editBuf[numRead+2]='\0';
d1277 2
a1278 2
	// insert at current position
	if (GetFocus() != hEditWnd) {
d1280 1
a1280 1
		SendMessage (hEditWnd, EM_SETSEL, (WPARAM)(INT)size, (LPARAM)(INT)size);
d1282 1
a1282 1
		SendMessage (hEditWnd, EM_SETSEL, (WPARAM)(UINT)1, MAKELONG(size,size));
d1284 5
a1288 5
	}
	SendMessage (hEditWnd, EM_REPLACESEL, 0, (LPARAM)(LPCSTR)editBuf);
  
  abortReadFile:
	GlobalFreePtr (editBuf);
d1295 48
a1342 51
	HFILE hFile;
	register unsigned int i;
	char *editBuf, *endPtr;
	unsigned int numRead;
	unsigned long size, expectedLen;

	if ((editBuf = GetEditText (hEditWnd)) == NULL)
		return;
		
	expectedLen = GetFileLength(fileName);
	size = strlen (editBuf) + expectedLen + 3;

	if (size > 60000L) {
		sprintf(str, "File %s is too large to read into the edit buffer.\nTry attaching it instead.", fileName);
		MessageBox (hEditWnd, str, "File Too Large", MB_OK|MB_ICONSTOP);
		goto abortReadFile;
	}		
	editBuf = GlobalReAllocPtr (editBuf, size, GMEM_MOVEABLE);
		
	if ((hFile = _lopen (fileName, OF_READ)) == HFILE_ERROR)
	{
		sprintf(str, "Could not open file %s for read", fileName);
		MessageBox (hEditWnd, str, "Attachment Open File Error", MB_OK);
		return;
	}
	
	endPtr = editBuf + strlen (editBuf);
		
	if ((numRead = _lread(hFile, endPtr, (unsigned int)expectedLen)) != expectedLen)
	{
		sprintf(str, "File %s not read correctly", fileName);
		MessageBox (hEditWnd, str, "File Read Error", MB_OK|MB_ICONSTOP);
		goto abortReadFile;
	}
	for (i = 0; i < numRead; i++) 
		if (!__isascii (endPtr[i]))
		{
			sprintf(str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
			MessageBox (hEditWnd, str, "Non-ASCII File Error", MB_OK|MB_ICONSTOP);
			_lclose(hFile);
			goto abortReadFile;
		}
	_lclose(hFile);
	endPtr[numRead]='\r';
	endPtr[numRead+1]='\n';
	endPtr[numRead+2]='\0';

	SetEditText (hEditWnd, editBuf);
  
  abortReadFile:
	GlobalFreePtr (editBuf);
d1356 35
a1390 36
	switch (tolower(line[0]))
	{
	case 'd': 
		return (!_strnicmp(line, "date", 4));
	case 'f': 
		return (!_strnicmp(line, "follow", 6) ||
 		 	!_strnicmp(line, "from", 4));
 	case 'k':
		return (!_strnicmp(line, "keywords", 8));
		
	case 'l':
		return (!_strnicmp(line, "lines", 5));
	case 'm':
		return (!_strnicmp(line, "message", 7));
	case 'n':
		return (!_strnicmp(line, "newsgrou", 8) ||
		  	!_strnicmp(line, "nntp", 4));
	case 'o':
		return (!_strnicmp(line, "organiza", 8) ||
		 	!_strnicmp(line, "originat", 8));
        case 'p':
		return (!_strnicmp(line, "path", 4));
	case 'r':
		return (!_strnicmp(line, "referenc", 8) ||
			!_strnicmp(line, "reply", 5));
	case 's':
 		return (!_strnicmp(line, "sender", 6) ||
 			!_strnicmp(line, "subject:", 8) ||
 			!_strnicmp(line, "summary", 7));
	case 'x':
		return (!_strnicmp(line, "xref:", 5) ||
		        !_strnicmp(line, "x-news", 6));
	default:
		return (0);
	}
}	
d1392 1
a1392 1
#endif                                                                       
d1402 1
a1402 1
CalcNumParts(unsigned long offset, TypAttachment *thisAttach)
d1404 6
a1409 1
	unsigned long workSize, cSize, pSize;
d1411 35
a1445 4
	if (!ArticleSplitLength) {
		thisAttach->numParts = 1;
		return;
	}
d1447 2
a1448 3
	// pre-flight the MIME stuff
	if (GenerateMIME) {
		GenerateMIMEAttachmentID();
d1450 4
a1453 35
		ResetTextBlock(WorkBlock);
		GenerateMIMEContentHeader(WorkBlock, thisAttach);
		cSize = WorkBlock->numBytes;	// goes only in 1st send
		
		ResetTextBlock(WorkBlock);
		GenerateMIMEPartialHeader(WorkBlock, thisAttach);
		pSize = WorkBlock->numBytes;	// goes in all partial sends
	} else {
		cSize = pSize = 0;
//		pSize = strlen(CUT_HERE_TEXT);
	}
	// gen subject before calculating numParts		
	GenerateSubject (MainHeader, thisAttach, 1);		// dummy part num
				
	offset += cSize;
				
	// total size of encoded attachment 
	if (EncodingTypeToNum(thisAttach->encodingType) != CODE_NONE) {
		workSize = (thisAttach->numBytes * 4)/3;
		workSize += (workSize/ENCODE_LINE_LEN)*2;		// \r\n for each line
	} else {
		workSize = thisAttach->numBytes;
	}
	thisAttach->numParts = 1;
	if (workSize + offset > (unsigned long)ArticleSplitLength) {
		// total # attachment bytes to go after first send
		workSize -= (ArticleSplitLength - offset - pSize);
	
		// calc number of bytes from attachment that will fit in each subsequent send
		offset = ArticleSplitLength - MainHeader->numBytes - pSize;
	
		// how many more sends required after first for this attachment
		thisAttach->numParts += (int)((workSize + offset) / offset);
	}
	return;
a1455 1

@


1.10
log
@lots of changes for .93.0
@
text
@d18 1
a18 1
 * $Id: wvsend.c 1.9 1994/09/16 00:57:09 jcooper Exp $
d20 3
d290 4
a560 1
		UpdateAllNewsCommMenus();
d607 3
a634 1
		UpdateAllNewsCommMenus();
d687 1
a687 1
	
d689 3
a691 1
		SendOneLine(TextBlockLine(textBlock, i));
@


1.9
log
@zero-padding in subject template, cleanup for 92.6
@
text
@d3 1
a3 1
 *  MODULE    :  WVATTACH.C                                         *
d5 1
a5 2
 *  PURPOSE   : This file contains functions for attachments to     *
 *              mail or news posting                                *
d7 2
a8 1
 *  ENTRY POINTS: Attach ()                                         *
d12 4
d18 5
a22 2
 * $Id: wvattach.c 1.8 1994/08/24 17:59:26 jcooper Exp $
 * $Log: wvattach.c $
d53 1
a53 2

extern void 	UpdateBlockStatus ();	// in wvcoding.c
d57 3
a59 11
void	AppendPlainFileToPost (char *fileName);
BOOL	SplitCurrentHeader (TypTextBlock *header, TypTextBlock *body, TypTextBlock *tail, char *origSubject);
BOOL	AddMIMEVersion (TypTextBlock *header);
BOOL	InitiateAttach (int useWnd, int DocType);
void	EndAttach ();
void	PostTextBlock (TypTextBlock *block);
unsigned long PostPartialTextBlock (TypTextBlock *block, unsigned long start, unsigned long maxBytes);
int 	PostOneLine (char *str, unsigned long *byteCount, unsigned long maxBytes);
void	GenerateSubject (TypTextBlock *header, char *origSubject, unsigned int part, unsigned int numParts);
HWND	CreateGlobalPostingWnd (HWND hWnd);
void 	FlushCommSpool ();
d61 17
d81 2
a82 1
// NUM_ENCODING_TYPES should be set in wvglob.h to the # items here
d85 1
a85 1
// NUM_CONTENT_TYPES should be set in wvglob.h to the # items here
d98 2
a99 6
#define CURRENT_WND 	1
#define NEW_WND		2
#define EDIT_SIZE_INC	512

#define ATTACH_NONE              0
#define ATTACH_START             1 	// state constants for ProcessAttachment
d102 1
a102 1
#define ATTACH_WAIT              4
d105 1
d107 3
a109 4
HWND hThisEditWnd;
HWND hParentWnd;
TypTextBlock *headerBlock, *body, *attachment, *tail;
unsigned int thisPart, numParts;
d111 2
a112 3
char attachmentID[MAXINTERNALLINE], origSubject[MAXINTERNALLINE];	
WndEdit *thisPostWnd;
int thisDocType;
d114 1
a114 5
unsigned int editSize;		// cannot exceed 64k in an edit window
unsigned int editMaxSize;
char *editMem;
int aMode;				// attachment mode for ended line chars
int saveReviewAttach;
d116 4
a119 3
#define MAX_COMM_SPOOL 1000
unsigned int commSpoolLen;
char *commSpool;
d143 1
a143 7
 * hParentWnd is handle to multi-line edit posting window
 *	Called by wvpost.c after file selected and attachment dialog completed
 *	Based on globals set in attachment dialog, creates attachment
 *	possibly encoded, with MIME headers, and posts it
 *	
 *	If ReviewAttach is set, add attachment to post/mail windows (creating
 *	new windows as necessary for message/partial)
d145 1
a145 2
void
Attach (WndEdit *WndPost, char *fileName, int DocType)
d147 18
a164 17
	time_t theTime;
	unsigned long offset, mimeUsage;
			
	hParentWnd = WndPost->hWnd;
	hThisEditWnd = WndPost->hWndEdit;
	WndPost->dirty = DT_DIRTY;
	thisDocType = DocType;
	thisPostWnd = WndPost;	
	// Initialize text blocks
	if ((headerBlock= InitTextBlock (hCodedBlockWnd)) == NULL)
		return;
	if ((body       = InitTextBlock (hCodedBlockWnd)) == NULL)
		return;
	if ((tail       = InitTextBlock (hCodedBlockWnd)) == NULL)
		return;
	if ((attachment = InitTextBlock (hCodedBlockWnd)) == NULL)
		return;
d166 13
a178 1
	aMode = ADD_TO_EDIT;	// end all lines in \r\n
d180 21
a200 9
	if (!ReviewAttach)
	{
		if ((commSpool = (char *)GlobalAllocPtr (GMEM_MOVEABLE, MAX_COMM_SPOOL*sizeof (char))) == NULL)
		{
			MessageBox (hParentWnd, "Memory allocation failure", "Comm Spool Init Failed", MB_OK);
			return;
		}			
		commSpool[0] = '\0';
		commSpoolLen = 0;
d203 17
a219 6
	saveReviewAttach = ReviewAttach;
	if (DocType == DOCTYPE_MAIL)
		ReviewAttach = TRUE;			// must review when mailing
		
	CreateStatusArea (hParentWnd);		// init hCodedBlockWnd and currentCoded
	strcpy (currentCoded->ident, fileName);	// status info
d221 6
a226 4
	if (EncodingTypeNum == CODE_NONE)
	{		
		if (ReadFileToTextBlock (hParentWnd, attachment, fileName, aMode) == FAIL)
			{  FinishAttachment (ABORT); return;  }
d228 1
a228 2
	else 	if (Encode (attachment, fileName, aMode) == FAIL)
		{  FinishAttachment (ABORT); return;  }
d230 12
a241 2
	CodingState = ATTACH_POSTING;
	InvalidateRect (hCodedBlockWnd, NULL, TRUE);	// clear background
d243 9
a251 9
	time (&theTime);
	sprintf (attachmentID, "\"%ld@@%s\"", theTime, UserName);
        
	if (SplitCurrentHeader (headerBlock, body, tail, origSubject))
		{  FinishAttachment (ABORT); return;  }
	
	if (!GenerateMIME || BlankBeforeMIME)
	   if (AddEndedLineToTextBlock (headerBlock, "", aMode))
		{  FinishAttachment (ABORT); return;  }
d253 15
a267 8
        if (GenerateMIME && AddMIMEVersion (headerBlock))
        	{  FinishAttachment (ABORT); return;  }
  
	// if header+tail won't fit in ArticleSplitLength bytes, can't do it
	if (headerBlock->numBytes + tail->numBytes + 200 > ArticleSplitLength)
	{
		MessageBox (hCodedBlockWnd, "Article split length too short to contain headers", "Article Split Length Too Small", MB_OK);
		FinishAttachment (ABORT); return;
d269 1
d271 38
a308 6
	// if the attachment won't fit in this article, force start in next
	if (!AttachInNewArt && 
	   (body->numBytes + headerBlock->numBytes + tail->numBytes + 200 > ArticleSplitLength))
	{
		MessageBox (hCodedBlockWnd, "Beginning attachment in next article", "Edit Window Space Shortage", MB_OK);
		AttachInNewArt == TRUE;
d310 9
a318 16
	
	if (ArticleSplitLength > 0)
	{
		offset = (AttachInNewArt) ? 0 : body->numBytes;
		// calc encodelength/splitlength rounded up
		numParts = (int)((attachment->numBytes + offset + 
			 ArticleSplitLength) / ArticleSplitLength);
		// now add in the length of header+sig for each part
		// the extra 200 bytes is rough avg for the MIME headers
		// on each part.  Round up to next articlesplitlen
		mimeUsage = GenerateMIME ? 200L : 0L;
		numParts = (int)((attachment->numBytes + offset + 
			 (long)numParts*(headerBlock->numBytes + tail->numBytes + mimeUsage) + 
			 ArticleSplitLength) / ArticleSplitLength);
        } else
        	numParts = 1;
d320 3
a322 2
	AttachmentState = ATTACH_START;
	ProcessAttach (CONTINUE);
d326 1
a326 1
 * ProcessAttach
d329 3
a331 3
 * Thus in !ReviewMode, after an Initiate/EndAttach, we give up control
 * and wvutil calls ProcessAttach when ready to continue
 */
d333 1
a333 1
ProcessAttach (int action)
d335 1
a335 1
	static unsigned long attachLine, byteCount, saveHeaderLines, saveHeaderBytes, dummyLong;
d338 4
a341 2
	static int abort;
	int i, found;
d343 2
a344 3
	if (action == ABORT) 
	{
		MessageBox (hCodedBlockWnd, "Posting with attachment aborted", "Attachment", MB_OK|MB_ICONHAND);
a352 1
		byteCount = 0;
a353 3
		attachLine = 0;
		saveHeaderLines = headerBlock->numLines;
		saveHeaderBytes = headerBlock->numBytes;
d356 11
a366 5

		if (AttachInNewArt)
		{
			thisPart = 0;
			AttachmentState = ATTACH_FIRST_IN_NEXT_WND;
d368 8
a375 6
		else
		{
			thisPart = 1;
			AttachmentState = ATTACH_FIRST_IN_THIS_WND;
		}
		currentCoded->sequence = thisPart;	// status window info
d377 2
a378 1
		if (InitiateAttach (CURRENT_WND, thisDocType))
a379 2
		if (!ReviewAttach)
			return;
d381 4
a384 5
		break;

	case ATTACH_FIRST_IN_THIS_WND:
		if (!ReviewAttach)
			CommState = ST_POST_WAIT_END;
d386 5
a390 4
		if (body->numLines != 0)	// if have body, then mixed
		{
		  GenerateSubject (headerBlock, origSubject, thisPart, numParts);
		  saveHeaderBytes = headerBlock->numBytes;
d392 5
a396 42
		  if (GenerateMIME)
		  {
		    if (AddEndedLineToTextBlock (headerBlock, "Content-Type: multipart/mixed;",aMode))
	  		{  AttachmentState = ATTACH_DONE; break;  }

		    sprintf (temp, "     Boundary=\"%s\"", MIMEBoundary);
		    if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		  
		    // blank preamble here
		    // each boundary must be preceded by a CRLF (add "")
		    if (AddEndedLineToTextBlock (headerBlock, "", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		    sprintf (temp, "--%s", MIMEBoundary);
		    if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
                  
                    // explicitly type the encapsulated section
		    if (AddEndedLineToTextBlock (headerBlock, "Content-Type: text/plain", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		    if (AddEndedLineToTextBlock (headerBlock, "", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		  
		    if (AddEndedLineToTextBlock (body, "", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		    sprintf (temp, "--%s", MIMEBoundary);
		    if (AddEndedLineToTextBlock (body, temp, aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		  } 
		  else	// no MIME
		  {
  		    if (AddEndedLineToTextBlock (body, "", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
  		    if (AddEndedLineToTextBlock (body, "BEGIN --- CUT HERE --- Cut Here --- cut here ---", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		  }
		  PostTextBlock (headerBlock);
		  PostTextBlock (body);
		  MultipartMixed = TRUE;
		  byteCount = headerBlock->numBytes + body->numBytes;
		}
		AttachmentState = ATTACH_MAIN;
d399 3
a401 4
	case ATTACH_FIRST_IN_NEXT_WND:
		// post current stuff, begin attachment in NEXT article
		if (!ReviewAttach)
			CommState = ST_POST_WAIT_END;
d403 4
a406 7
		GenerateSubject (headerBlock, origSubject, thisPart, numParts);
		saveHeaderBytes = headerBlock->numBytes;
		
		if (GenerateMIME)
		{
                  if (AddEndedLineToTextBlock (headerBlock, "Content-Type: text/plain", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
d408 6
a413 19
		if (AddEndedLineToTextBlock (headerBlock, "", aMode))
			{  AttachmentState = ATTACH_DONE; break;  }
		PostTextBlock (headerBlock);
		PostTextBlock (body);  
		PostTextBlock (tail);  

		thisPart = 1;
		currentCoded->sequence = thisPart;	// status window info
		AttachmentState = ATTACH_WAIT;

		EndAttach ();
		if (!ReviewAttach)
			return;

		break;

	case ATTACH_WAIT:
		if (InitiateAttach (NEW_WND, thisDocType))
			{  AttachmentState = ATTACH_DONE; break;  }
a414 3
		if (!ReviewAttach)
			return;

d418 2
a419 1
		if (!ReviewAttach)
d421 2
d424 2
a425 10
		headerBlock->numLines = saveHeaderLines;	// reset to orig header
		headerBlock->numBytes = saveHeaderBytes;

		GenerateSubject (headerBlock, origSubject, thisPart, numParts);
		saveHeaderBytes = headerBlock->numBytes;
                if (GenerateMIME)
                {
		  if (numParts > 1)
		  {
			if (AddEndedLineToTextBlock (headerBlock, "Content-Type: message/partial;", aMode))
d427 1
a427 6
			sprintf (temp, "     id=%s;", attachmentID);
			if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
				{  AttachmentState = ATTACH_DONE; break;  }
			sprintf (temp, "     number=%d; total=%d", thisPart, numParts);
			if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
				{  AttachmentState = ATTACH_DONE; break;  }
d429 4
a432 33
			if (AddEndedLineToTextBlock (headerBlock, "", aMode))
				{  AttachmentState = ATTACH_DONE; break;  }
		  }
		  if (thisPart == 1)
		  {
	 		for (i = 0, found = FALSE; i < NUM_CONTENT_TYPES && !found; i++)
				if (!_stricmp (ContentType, ContentTypes[i]))
					found = TRUE;

			if (!_stricmp (ContentType, "Other") || !found)
				sprintf (temp, "Content-Type: Application/octet-stream");
			else					
				sprintf (temp, "Content-Type: %s", ContentType);

			if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
				{  AttachmentState = ATTACH_DONE; break;  }
			         
			switch (EncodingTypeNum)
			{
			case CODE_UU:	
				sprintf (temp, "Content-Transfer-Encoding: %s", MIMEUUType);
				break;
			case CODE_XX:
				sprintf (temp, "Content-Transfer-Encoding: %s", MIMEXXType);
				break;
			case CODE_CUSTOM:
				sprintf (temp, "Content-Transfer-Encoding: %s", MIMECustomType);
				break;
			case CODE_BASE64:
				strcpy (temp, "Content-Transfer-Encoding: Base64");
				break;
			case CODE_NONE:
				temp[0] = '\0';
d434 1
a434 7
			if (temp[0] != '\0' &&
			   (AddEndedLineToTextBlock (headerBlock, temp, aMode)))
				{  AttachmentState = ATTACH_DONE; break;  }

			if (AddEndedLineToTextBlock (headerBlock, "",aMode))
				{  AttachmentState = ATTACH_DONE; break;  }
		  }
d436 3
d440 5
a444 7
		// if multipart/mixed and first part, then the main header 
		// was already displayed, so we now want to post from the end 
		// of that header on (byteCount already set above)
		if (MultipartMixed && thisPart == 1)
		{
			if (GenerateMIME)
				PostPartialTextBlock (headerBlock, saveHeaderLines, byteCount-saveHeaderBytes);
d446 6
a451 23
		else                                
		{
			PostTextBlock (headerBlock);
			byteCount = headerBlock->numBytes;
		}

		if (numParts > 1)
		{
			if (attachLine == attachment->numLines)
			{
				sprintf (temp, "[WinVn: Humble apologies: the # of attachment blocks was estimated incorrectly]\r");
				if (aMode == ADD_TO_EDIT) 
					strcat (temp, "\n");
				PostOneLine (temp, &dummyLong, 0);
				thisPart = numParts;
			}
			else
			{
				// calculate number of bytes from attachment to use 
				// in this part: we've already used byteCount bytes
				// in headers, and we need to leave room for the tail
				byteCount = ArticleSplitLength - byteCount - tail->numBytes;
				if ((attachLine = PostPartialTextBlock (attachment, attachLine, byteCount)) == 0)
d453 3
d458 3
a460 6
		else
			PostTextBlock (attachment);
		
		// if this is the last section, don't end it since we may
		// still have a boundary and a tail to add
		if (thisPart + 1 <= numParts) 
d462 3
a464 2
			thisPart++;
			AttachmentState = ATTACH_WAIT;
d466 2
a467 2
			currentCoded->sequence = thisPart;	// status window info
			currentCoded->numLines = 0;
d469 4
a472 2
			EndAttach ();
			if (!ReviewAttach)
d477 6
a482 16
			// if multi-part/mixed then need to attach the final boundary
			if (GenerateMIME && MultipartMixed)
			{
				ResetTextBlock (body);
				if (AddEndedLineToTextBlock (body, "", aMode))
					{  AttachmentState = ATTACH_DONE; break;  }
				sprintf (temp, "--%s--", MIMEBoundary);
				if (AddEndedLineToTextBlock (body, temp, aMode))
					{  AttachmentState = ATTACH_DONE; break;  }
				PostTextBlock (body);
			}	
				
			// Signature/tail ends up after last boundary, in epilogue
			PostTextBlock (tail);
			AttachmentState = ATTACH_DONE;
			abort = CONTINUE;		// successful
d484 27
a510 3
			EndAttach ();
			if (!ReviewAttach)
				return;
d515 1
a515 1
		FinishAttachment (abort); 
d525 6
a530 2
void
FinishAttachment (int action)
d532 1
a532 8
	char temp[255];
	
	FreeTextBlock (headerBlock);
	FreeTextBlock (body);
	FreeTextBlock (attachment);
	
	CodingState = INACTIVE;
	DestroyStatusArea();
d534 9
a542 12
	// if we are managing the post (not reviewing), then we must close the
	// one post window when we're through (don't close if aborted)
	if (!ReviewAttach)
	{
		if (action == CONTINUE)
		{
			sprintf (temp, "Posting completed in %d part", numParts);
			if (numParts > 1)
				strcat (temp, "s");
				
			MessageBox (thisPostWnd->hWnd, temp, "Posting done", MB_OK|MB_ICONINFORMATION);
			DestroyWindow (thisPostWnd->hWnd);
d544 16
a559 3
		GlobalFreePtr (commSpool);
	}		
	ReviewAttach = saveReviewAttach;
a561 13
/* ------------------------------------------------------------------------
 * 	Reads current text from the posting edit buffer, 
 *	splits all RFC822 header stuff into header block,
 *		save off subject line from header during copy
 *	and body up to any signature into the body block.
 *	from signature on goes into tail block
 *	This is so we can insert our MIME stuff right in between
 *	Assumes there is a null (blank) line between RFC822 header and body
 *	Tailing signature
 */
#define READING_HEADER 	1
#define READING_BODY    2
#define READING_TAIL    3
d563 1
a563 1
SplitCurrentHeader (TypTextBlock *header, TypTextBlock *body, TypTextBlock *tail, char *origSubject)
d565 2
a566 7
        char *editBuf, *ptr, *end;
        int state;
	char temp[MAXINTERNALLINE];
	        
	origSubject[0] = '\0';
	if ((editBuf = GetEditText (hThisEditWnd)) == NULL)
		return (FAIL);
d568 8
a575 7
	for (state = READING_HEADER, ptr = editBuf; *ptr != '\0';)
	{
		end = strstr (ptr, "\r\n");     // all edit buf lines end in \r\n
		if (end == NULL)
		{
			strcpy (temp, ptr);	// last line - no \r\n
			*ptr = '\0';		// finish loop, then stop
d577 5
a581 5
		else
		{
			*end = '\0';            // strip \r\n
			strcpy (temp, ptr);
			ptr = end + 2;          // skip \r\n for next line
d583 25
a607 16
		switch (state)
		{
		  case READING_HEADER:
			if (!IsBlankStr(temp))
			{
				if (AddEndedLineToTextBlock (header, temp, aMode))
					return (FAIL);;
				if (!_strnicmp (temp, "subject:", 8))
					strcpy (origSubject, temp);
			}
			else	// switch to reading body				    
			{
				state = READING_BODY;
				continue;
			}
			break;
d609 28
a636 20
		  case READING_BODY:
			if (body->numLines == 0 && IsBlankStr (temp))
				continue;	// skip leading blank lines
				
			if (EnableSig && Signature->numLines > 0 && 
			    !strcmp (temp, TextBlockLine (Signature, 0)))
			{
				if (AddEndedLineToTextBlock (tail, temp, aMode))
					return (FAIL);
				state = READING_TAIL;
				continue;
			}
			if (AddEndedLineToTextBlock (body, temp, aMode))
				return (FAIL);
			break;
		
		  case READING_TAIL:
			if (AddEndedLineToTextBlock (tail, temp, aMode))
				return (FAIL);
        	}       
a637 8
	}
	GlobalFreePtr (editBuf);
	return (SUCCESS);
}	
	
/* ------------------------------------------------------------------------
 *	Start/end posting
 */
d639 1
a639 1
InitiateAttach (int useWnd, int DocType)
d641 8
a648 22
	WndEdit *NewWndPost;
		
	if (ReviewAttach)
	{
		/* create new window for each posted section
		 * if attach-now or thisPart==0 use existing window for 1st section
		 */
		if (useWnd == NEW_WND)
		{
			if ((hParentWnd = CreatePostingWnd (hParentWnd, NULL, DocType)) == NULL)
			{
				MessageBox (hParentWnd, "Failed to create new attachment window", "Posting Window Creation", MB_OK);
				return (FAIL);
			}
							
			if (DocType == DOCTYPE_POSTING)
			   NewWndPost = getWndEdit(WndPosts, hParentWnd, MAXPOSTWNDS);
			else
			   NewWndPost = getWndEdit(WndMails, hParentWnd, MAXMAILWNDS);
			
			NewWndPost->dirty = DT_DIRTY;
			hThisEditWnd = NewWndPost->hWndEdit;
d650 5
a654 6
		sprintf (str, "Review Attachment Part %d of %d", thisPart, numParts);
		SetWindowText (hParentWnd, str);
		if ((editMem = (char *) GlobalAllocPtr (GMEM_MOVEABLE|GMEM_ZEROINIT, EDIT_SIZE_INC*sizeof(char))) == NULL)
		{
			MessageBox (hParentWnd, "Memory allocation failure", "Attachment", MB_OK);
			return (FAIL);
d656 12
a667 6
		editMaxSize = EDIT_SIZE_INC;
		editSize = 0;
	}
	else		
		if (!StartPost (thisPostWnd))
			return (FAIL);
d669 4
a672 1
	return (SUCCESS);
d675 2
a676 2
void
EndAttach (HWND hParentWnd)
d678 1
a678 1
	unsigned long dummyLong;
d680 2
a681 4
	if (ReviewAttach)
	{
		SetEditText (hThisEditWnd, editMem);
		GlobalFreePtr (editMem);
d683 16
a698 4
	else
	{
		PostOneLine (".\r\n", &dummyLong, 0);
		FlushCommSpool ();
d700 31
d733 2
a734 2
void
FlushCommSpool ()
d736 4
a739 5
	if (commSpoolLen > 0)
	{
		PutCommData (commSpool, commSpoolLen);
		commSpoolLen = 0;
		commSpool[0] = '\0';
d743 55
d799 8
a806 3
 * Post the contents of a text block
 *	Assumes posting already initiated, and does not end the posting
 *	Lines must end in \r\n
d808 2
a809 3

int 
PostOneLine (char *str, unsigned long *byteCount, unsigned long maxBytes)
d811 4
a814 1
	unsigned int len;
d816 22
a837 5
	len = strlen (str);
		
	*byteCount += (long)len;
	if (maxBytes > 0 && *byteCount >= maxBytes)
		return (SUCCESS);
d839 19
a857 10
	if (ReviewAttach)
	{
		editSize += len;
		if (editSize >= editMaxSize)
		{
			editMaxSize += max(EDIT_SIZE_INC, len);
			if ((editMem = GlobalReAllocPtr (editMem, editMaxSize*sizeof(char), GMEM_MOVEABLE)) == NULL)
			{
				MessageBox (hThisEditWnd, "Memory allocation failure", "Build Attachment", MB_OK);
				return (FAIL);
d859 3
d863 11
a873 2
		strcat (editMem, str);
		currentCoded->numBytes = (long)editSize;
d875 8
a882 4
	else
	{
		if (commSpoolLen + len >= MAX_COMM_SPOOL)
			FlushCommSpool ();
d884 7
a890 3
		strcat (commSpool, str);
		commSpoolLen += len;
		currentCoded->numBytes += len;
d893 24
a916 1
	return (SUCCESS);
d919 5
a923 2
void
PostTextBlock (TypTextBlock *block)
d925 4
a928 1
	PostPartialTextBlock (block, 0L, 0L);
d931 2
a932 2
unsigned long
PostPartialTextBlock (TypTextBlock *block, unsigned long start, unsigned long maxBytes)
d934 1
a934 2
	register unsigned long i;
	unsigned long byteCount;
d936 2
a937 16
	byteCount = 0;	
			
	for (i = start; i < block->numLines; i++)
	{
		if (PostOneLine (TextBlockLine (block, i), &byteCount, maxBytes) == FAIL)
			return (0);
		
		if (maxBytes > 0 && byteCount >= maxBytes)
			break;
			
		currentCoded->numLines++;
		if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
			UpdateBlockStatus();
	}
	UpdateBlockStatus();	// show final size
	return (i);
d939 1
a939 3
/* ------------------------------------------------------------------------
 *	Add a line to the given header block which contains the MIME-Version
 */
d941 1
a941 1
AddMIMEVersion (TypTextBlock *header)
d944 3
d948 7
a954 3
	sprintf (temp, "MIME-Version: %s", MIME_VERSION);
	if (AddEndedLineToTextBlock (header, temp, aMode))
		return (FAIL);;
d956 26
a981 1
	return (SUCCESS);
d984 60
d1047 1
a1047 1
 *		Replace %f with AttachFileName
d1055 1
a1055 2
GenerateSubject (TypTextBlock *header, char *origSubject, 
		 unsigned int part, unsigned int numParts)
d1059 3
a1061 3
	char newSubject[MAXINTERNALLINE];
	char endLine[3], numStr[10];
	int numZeros;
d1064 1
a1064 6
	for (num = 0; num < header->numLines; num++)
		if (!_strnicmp (TextBlockLine (header, num), "subject:", 8))
			break;
		
	ptr = strpbrk (TextBlockLine (header, num), "\n\r");
	strcpy (endLine, ptr);
d1066 12
a1077 1
	for (src = SubjectTemplate, dest = newSubject; *src != NULL;)
d1091 7
a1097 1
				NameWithoutPath (str, AttachFileName);				
d1106 1
a1106 1
					itoa (numParts, numStr, 10);	// longer or equal in length to part
d1138 1
a1138 1
	strcat (dest, endLine);	// replace end of line
d1140 6
a1145 1
	ReplaceLineInTextBlock (header, num, newSubject);
a1147 2

#if OLD_PLAIN_FILE
d1149 1
a1149 1
 * 	Directly modifies the Edit buffer of the parent multi-line edit wnd
d1153 1
a1153 1
AppendPlainFileToPost (char *fileName)
d1157 20
a1176 5
        char *editBuf, *inBuf;
        unsigned int endPtr, size, numRead;
        
        inBuf = (char *) GlobalAllocPtr(GMEM_FIXED, 2048*sizeof(char));
	editBuf = GetEditText (hThisEditWnd);
d1178 1
a1178 2
	size = strlen (editBuf);        
	if ((hFile = _lopen (fileName, READ)) == HFILE_ERROR)
d1180 57
d1238 1
a1238 1
		MessageBox (hParentWnd, str, "Attachment Open File Error", MB_OK);
d1242 1
a1242 11
    	while (1)
    	{
   		if ((numRead = _lread(hFile, inBuf, 2048)) == 0)
    			break;
       		for (i = 0; i < numRead; i++)
		  if (!__isascii (inBuf[i]))
		  {
			sprintf(str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
			MessageBox (hParentWnd, str, "Non-ASCII File Error", MB_OK);
			goto endAppend;
		  }
d1244 5
a1248 4
		endPtr = size;
		size += numRead;
		editBuf = GlobalReAllocPtr (editBuf, size, GMEM_MOVEABLE);
		memmove (editBuf + endPtr, inBuf, numRead);
d1250 8
a1257 2
   
   endAppend:;
d1259 3
d1263 4
a1266 3
	SetEditText (hThisEditWnd, editBuf);
        GlobalFreePtr (editBuf);
        GlobalFreePtr (inBuf);
d1268 1
a1268 1
#endif                                                                       
d1318 60
@


1.8
log
@misc encoding/decoding changes
@
text
@d14 1
a14 1
 * $Id: wvattach.c 1.7 1994/08/11 00:09:17 jcooper Exp $
d16 3
d40 3
a45 2
#include "wvglob.h"
#include "winvn.h"
a163 1
	Attaching = TRUE;
d251 1
a251 1
ProcessAttach (int cancel)
d259 1
a259 1
	if (cancel) 
d541 1
a541 1
FinishAttachment (int abort)
a547 1
	Attaching = FALSE;
d556 1
a556 1
		if (abort == CONTINUE)
d819 1
d830 3
a832 2
	char numStr[MAXINTERNALLINE], newSubject[MAXINTERNALLINE];
	char endLine[3];
d859 16
d879 1
d884 1
@


1.7
log
@Enhancements to Mime and article encoding/encoding
@
text
@d14 1
a14 1
 * $Id: wvattach.c 1.6 1994/06/09 18:51:30 rushing Exp $
d16 3
d737 3
a741 3
		if (maxBytes > 0 && *byteCount >= maxBytes)
			return (SUCCESS);

@


1.6
log
@problem with symbol 'header' on AXP/NT
@
text
@d6 1
a6 1
 *              mail or posting                                     *
d10 1
a10 1
 * Author: John S. Cooper (jcoop@@apl.com)                           *
d14 1
a14 1
 * $Id: wvattach.c 1.5 1994/05/23 18:37:00 jcooper Exp $
d16 3
d140 1
a140 1
	unsigned long offset;
d181 1
a181 1
			{  FinishAttachment (TRUE); return;  }
d184 1
a184 1
		{  FinishAttachment (TRUE); return;  }
d193 1
a193 1
		{  FinishAttachment (TRUE); return;  }
d195 1
a195 1
	if (BlankBeforeMIME)
d197 1
a197 1
		{  FinishAttachment (TRUE); return;  }
d199 2
a200 2
        if (AddMIMEVersion (headerBlock))
        	{  FinishAttachment (TRUE); return;  }
d206 1
a206 1
		FinishAttachment (TRUE); return;
d215 2
a216 1
	}		
d226 1
d228 1
a228 1
			 (long)numParts*(headerBlock->numBytes + tail->numBytes + 200) + 
d234 1
a234 1
	ProcessAttach (0);
d259 1
a259 1
 while (AttachmentState != ATTACH_NONE) {
d263 1
a263 1
		abort = TRUE;
d300 3
a302 1
		  if (AddEndedLineToTextBlock (headerBlock, "Content-Type: multipart/mixed;",aMode))
d305 2
a306 2
		  sprintf (temp, "     Boundary=\"%s\"", MIMEBoundary);
		  if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
d309 3
a311 3
		  // blank preamble here
		  // each boundary must be preceded by a CRLF (add "")
		  if (AddEndedLineToTextBlock (headerBlock, "", aMode))
d313 2
a314 2
		  sprintf (temp, "--%s", MIMEBoundary);
		  if (AddEndedLineToTextBlock (headerBlock, temp, aMode))
d317 2
a318 2
                  // explicitly type the encapsulated section
		  if (AddEndedLineToTextBlock (headerBlock, "Content-Type: text/plain", aMode))
d320 1
a320 1
		  if (AddEndedLineToTextBlock (headerBlock, "", aMode))
d323 1
a323 1
		  if (AddEndedLineToTextBlock (body, "", aMode))
d325 2
a326 2
		  sprintf (temp, "--%s", MIMEBoundary);
		  if (AddEndedLineToTextBlock (body, temp, aMode))
d328 8
d338 1
a339 1
		  MultipartMixed = TRUE;
d351 4
a354 1
		if (AddEndedLineToTextBlock (headerBlock, "Content-Type: text/plain", aMode))
d356 1
d391 4
a394 3

		if (numParts > 1)
		{
d406 4
a409 4
		}
		if (thisPart == 1)
		{
			for (i = 0, found = FALSE; i < NUM_CONTENT_TYPES && !found; i++)
d414 1
a414 1
				sprintf (temp, "Content-Type: X-%s", ContentType);				
d420 1
a420 1
			
d424 1
a424 1
				strcpy (temp, "Content-Transfer-Encoding: X-uue");
d427 1
a427 1
				strcpy (temp, "Content-Transfer-Encoding: X-xxe");
d430 1
a430 1
				strcpy (temp, "Content-Transfer-Encoding: X-User-Defined");
d441 1
d444 1
d451 2
d454 1
d465 1
a465 1
				sprintf (temp, "Most humble apologies: the # of attachment blocks was estimated incorrectly\r");
d480 2
a481 1
		} else
d501 1
a501 1
			if (MultipartMixed)
d515 1
a515 1
            abort = FALSE;		// successful
d527 5
a531 3
	}
 }
 return;
d551 1
a551 1
		if (!abort)
@


1.5
log
@new attach code, session [dis]connect
@
text
@d14 1
a14 1
 * $Id: wvattach.c 1.3 1994/02/24 21:27:10 jcoop Exp $
d16 3
d86 1
a86 1
TypTextBlock *header, *body, *attachment, *tail;
d145 1
a145 1
	if ((header     = InitTextBlock (hCodedBlockWnd)) == NULL)
d189 1
a189 1
	if (SplitCurrentHeader (header, body, tail, origSubject))
d193 1
a193 1
	   if (AddEndedLineToTextBlock (header, "", aMode))
d196 1
a196 1
        if (AddMIMEVersion (header))
d200 1
a200 1
	if (header->numBytes + tail->numBytes + 200 > ArticleSplitLength)
d208 1
a208 1
	   (body->numBytes + header->numBytes + tail->numBytes + 200 > ArticleSplitLength))
d223 1
a223 1
			 (long)numParts*(header->numBytes + tail->numBytes + 200) + 
d262 2
a263 2
		saveHeaderLines = header->numLines;
		saveHeaderBytes = header->numBytes;
d292 2
a293 2
		  GenerateSubject (header, origSubject, thisPart, numParts);
		  saveHeaderBytes = header->numBytes;
d295 1
a295 1
		  if (AddEndedLineToTextBlock (header, "Content-Type: multipart/mixed;",aMode))
d299 1
a299 1
		  if (AddEndedLineToTextBlock (header, temp, aMode))
d304 1
a304 1
		  if (AddEndedLineToTextBlock (header, "", aMode))
d307 1
a307 1
		  if (AddEndedLineToTextBlock (header, temp, aMode))
d311 1
a311 1
		  if (AddEndedLineToTextBlock (header, "Content-Type: text/plain", aMode))
d313 1
a313 1
		  if (AddEndedLineToTextBlock (header, "", aMode))
d321 1
a321 1
		  PostTextBlock (header);
d323 1
a323 1
		  byteCount = header->numBytes + body->numBytes;
d334 3
a336 3
		GenerateSubject (header, origSubject, thisPart, numParts);
		saveHeaderBytes = header->numBytes;
		if (AddEndedLineToTextBlock (header, "Content-Type: text/plain", aMode))
d338 1
a338 1
		if (AddEndedLineToTextBlock (header, "", aMode))
d340 1
a340 1
		PostTextBlock (header);
d367 2
a368 2
		header->numLines = saveHeaderLines;	// reset to orig header
		header->numBytes = saveHeaderBytes;
d370 2
a371 2
		GenerateSubject (header, origSubject, thisPart, numParts);
		saveHeaderBytes = header->numBytes;
d375 1
a375 1
			if (AddEndedLineToTextBlock (header, "Content-Type: message/partial;", aMode))
d378 1
a378 1
			if (AddEndedLineToTextBlock (header, temp, aMode))
d381 1
a381 1
			if (AddEndedLineToTextBlock (header, temp, aMode))
d384 1
a384 1
			if (AddEndedLineToTextBlock (header, "", aMode))
d398 1
a398 1
			if (AddEndedLineToTextBlock (header, temp, aMode))
d419 1
a419 1
			   (AddEndedLineToTextBlock (header, temp, aMode)))
d421 1
a421 1
			if (AddEndedLineToTextBlock (header, "",aMode))
d429 1
a429 1
				PostPartialTextBlock (header, saveHeaderLines, byteCount-saveHeaderBytes);
d432 2
a433 2
			PostTextBlock (header);
			byteCount = header->numBytes;
d511 1
a511 1
	FreeTextBlock (header);
d948 1
a948 1
#endif                                                                       @


1.4
log
@changes for gensock & version 0.91
@
text
@d14 1
a14 1
 * $Id: wvattach.c 1.3 1994/02/24 21:27:10 jcoop Exp rushing $
d45 1
d48 1
d53 2
d56 13
d73 8
d83 7
d93 27
a119 3
int aMode;			// attachment mode for ended line chars
unsigned int thisPart, numParts;
TypTextBlock *thisPostText;
d122 1
a122 1
 * 	hParentWnd is handle to multi-line edit posting window
a132 3
	register unsigned long byteCount;
        TypTextBlock *header, *body, *attachment, *tail;
        char attachmentID[MAXINTERNALLINE], origSubject[MAXINTERNALLINE];	
d134 1
a134 3
	unsigned long line, saveHeaderLines, saveHeaderBytes, offset;
	char temp[MAXINTERNALLINE];
	BOOL MultipartMixed;
d139 2
a140 8

	Attaching = TRUE;
	MultipartMixed = FALSE;
	if (ReviewAttach)
		aMode = ADD_TO_EDIT;
	else
		aMode = ADD_TO_POST;
	
d151 18
d170 1
a170 1
        strcpy (currentCoded->ident, fileName);	// status info
d172 1
a172 1
	if (EncodingType == CODE_NONE)
d175 1
a175 1
			goto endAttach;
d177 2
a178 1
	else 	Encode (attachment, fileName, aMode);
a185 2
	byteCount = 0;

d187 1
a187 1
		goto endAttach;
d191 1
a191 1
		goto endAttach;
d194 1
a194 2
        	goto endAttach;

d200 1
a200 1
		goto endAttach;
d204 1
a204 1
	if (WhenToAttach == IDD_ATTACH_NOW && 
d208 1
a208 1
		WhenToAttach == IDD_ATTACH_NEXT;
a209 2
	saveHeaderLines = header->numLines;
	saveHeaderBytes = header->numBytes;
d212 1
a212 1
		offset = (WhenToAttach == IDD_ATTACH_NOW) ? body->numBytes : 0;
d225 21
a245 1
	if (WhenToAttach == IDD_ATTACH_NOW)
d247 13
a259 4
		thisPart = 1;
		if (InitiateAttach (CURRENT_WND, DocType))
			goto endAttach;
	  	GenerateSubject (header, origSubject, thisPart, numParts);
d261 26
d289 3
d293 1
a293 1
	  		goto endAttach;
d297 1
a297 1
			goto endAttach;
d302 1
a302 1
			goto endAttach;
d305 1
a305 1
			goto endAttach;
d309 1
a309 1
			goto endAttach;
d311 1
a311 1
			goto endAttach;
d314 1
a314 1
			goto endAttach;
d317 1
a317 1
			goto endAttach;
d323 8
a330 8
	}
	else
	{	// post current stuff, begin attachment in NEXT article
		if (body->numLines == 0)	// if have body, then mixed
			;// Mention to the user that there's no body...
		thisPart = 0;
		if (InitiateAttach (CURRENT_WND, DocType))
		goto endAttach;
d332 1
d334 1
a334 1
			goto endAttach;
d336 1
a336 1
			goto endAttach;
d340 5
d346 20
a366 3
		thisPart = 1;
		if (InitiateAttach (NEW_WND, DocType))
			goto endAttach;
a368 12
	}
	for (line = 0; thisPart <= numParts; thisPart++)
	{		
		if (line == attachment->numLines)
		{
			MessageBox (hCodedBlockWnd, "Ok, Ok, I calculated the number of parts wrong. Sorry.", "So Kill Me", MB_OK);
			break;
		}
		header->numLines = saveHeaderLines;	// reset to orig header
		header->numBytes = saveHeaderBytes;
//		for (i = saveHeaderLines; i < header->numLines; i++)
//			GlobalFreePtr (header->text[i]);
a369 7
		if (thisPart > 1)			// 1st handled above
		{
			if (InitiateAttach (NEW_WND, DocType))
				goto endAttach;
			GenerateSubject (header, origSubject, thisPart, numParts);
			saveHeaderBytes = header->numBytes;
		}
d373 1
a373 1
				goto endAttach;
d376 1
a376 1
				goto endAttach;
d379 1
a379 1
				goto endAttach;
d382 1
a382 1
				goto endAttach;
d386 6
a391 2
			if (!_stricmp (ContentType, "Other"))
				strcpy (temp, "Content-Type: X-Other");
d394 1
d396 1
a396 1
				goto endAttach;
d398 1
a398 1
			switch (EncodingType)
d417 1
a417 1
				goto endAttach;
d419 1
a419 1
				goto endAttach;
d426 1
a426 1
			PostPartialTextBlock (header, saveHeaderLines, byteCount-saveHeaderBytes);
d435 17
a451 6
			// calculate number of bytes from attachment to use 
			// in this part: we've already used byteCount bytes
			// in headers, and we need to leave room for the tail
			byteCount = ArticleSplitLength - byteCount - tail->numBytes;
			if ((line = PostPartialTextBlock (attachment, line, byteCount)) == 0)
				goto endAttach;
a454 3
		currentCoded->sequence++;	// status window info
		currentCoded->numLines = 0;
		
d457 31
a487 1
		if (thisPart + 1 <= numParts)
d489 9
d499 3
a501 15
	// if multi-part/mixed then need to attach the final boundary
	if (MultipartMixed)
	{
		ResetTextBlock (body);
		if (AddEndedLineToTextBlock (body, "", aMode))
			goto endAttach;
		sprintf (temp, "--%s--", MIMEBoundary);
		if (AddEndedLineToTextBlock (body, temp, aMode))
			goto endAttach;
		PostTextBlock (body);
	}	
		
	// Signature/tail ends up after last boundary, in epilogue
	PostTextBlock (tail);
	EndAttach ();
d503 5
a507 1
   endAttach:;	
d515 17
d533 1
d622 1
a622 1
	
a653 1
/*
d655 1
a655 1
		if (!StartPost(WndPost))	//!!!! FIX THIS!
d657 1
a657 1
*/
d660 1
d664 2
d672 15
a686 1
		PutCommLine (".");
d688 1
d690 1
a690 1
 *      Post the contents of a text block
d692 1
a692 2
 *	Lines in an edit buffer must end in \r\n
 *	Posted lines have no end chars (PutCommLine adds a \n)
d694 40
a743 1
	register unsigned int len;
d750 2
a751 1
		len = strlen (TextBlockLine (block, i));
d753 3
a755 22
		if (ReviewAttach)
		{
			byteCount += (long)len;
			if (maxBytes > 0 && byteCount >= maxBytes)
				break;

			editSize += len;
			if (editSize >= editMaxSize)
			{
				editMaxSize += max(EDIT_SIZE_INC, len);
				if ((editMem = GlobalReAllocPtr (editMem, editMaxSize*sizeof(char), GMEM_MOVEABLE)) == NULL)
				{
					MessageBox (hThisEditWnd, "Memory allocation failure", "Build Attachment", MB_OK);
					return 0;
				}
			}
			strcat (editMem, TextBlockLine (block, i));
			len = strlen (editMem);
		}
		else
			PutCommLine (TextBlockLine (block, i));
				
a756 1
		currentCoded->numBytes = (long)editSize;
d943 1
a943 3
}

#endif
d945 1
@


1.3
log
@jcoop changes
@
text
@d14 1
a14 1
 * $Id: wvattach.c 1.2 1994/01/22 01:30:03 jcoop Exp $
d16 3
d487 1
a487 1
		PutCommLine (".\r", 2);
d534 1
a534 1
			PutCommLine (TextBlockLine (block, i), len);
d724 3
a726 1
}	
a727 1
#endif                                                                       @


1.2
log
@90.2 changes
@
text
@d14 1
a14 1
 * $Id: wvattach.c 1.1 1994/01/16 12:10:08 jcoop Exp $
d16 3
d106 1
a106 1
	if (EncodingType == ENCODE_NONE)
d271 1
a271 1
			case ENCODE_UU:	
d274 1
a274 1
			case ENCODE_XX:
d277 1
a277 1
			case ENCODE_CUSTOM:
d280 1
a280 1
			case ENCODE_BASE64:
d283 1
a283 1
			case ENCODE_NONE:
a477 1
LRESULT x;
d480 1
a480 1
		x=SetEditText (hThisEditWnd, editMem);
@


1.1
log
@Initial revision
@
text
@d14 5
a18 2
 * $Id: $
 * $Log: $
d465 1
d467 1
a467 1
		if (!StartPost(hParentWnd))		// !!!! FIX THIS!
d469 1
a469 1

@
